using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace Moving_Forms_Test
{
    partial class Form1
    {
        private void CreateKKCSV(string KKCSVName)
        {
            // set all data accordingly for Micro
            Micro.SampleRate = 192000;
            MicroMHz.FFTSize = 262144;
            Micro.stepSize.Text = "10Hz";
            Micro.Mode.Text = "USB";
            Micro.VolumeTrackBar.Value = 8;
            Micro.SafeTrackBarValueChange(43, Micro.AGCTrackBar);
            Micro.AGCSpeed.Text = "Fast";
            MicroMHz.GridMax = -45;
            MicroMHz.GridMin = -85;
            MicroMHz.GridStep = 5;
            Moving_Forms_Test.MicroMHz.color_scheme = "enhanced";
            Micro.WaterfallHighThreshold = -45;
            Micro.WaterfallLowThreshold = -85;
            Micro.BandwidthTrackBar.Value = 3382;
            Micro.ANF.Checked = false;
            Micro.NR.Checked = false;
            Micro.NB1.Checked = false;
            Micro.NB2.Checked = false;
            Micro.Rate = 3;          
            Micro.KKDevice = KKMethod.Ethernet;
            MicroMHz.w3szendpoint1 = "192.168.1.111";
                      
            // set all data accordingly for _50
            _50.SampleRate = 192000;
            _50MHz.FFTSize = 262144;
            _50.stepSize.Text = "10Hz";
            _50.Mode.Text = "USB";
            _50.VolumeTrackBar.Value = 8;
            _50.SafeTrackBarValueChange(43, _50.AGCTrackBar);
            _50.AGCSpeed.Text = "Fast";
            _50MHz.GridMax = -45;
            _50MHz.GridMin = -85;
            _50MHz.GridStep = 5;
            Moving_Forms_Test._50MHz.color_scheme = "enhanced";
            _50.WaterfallHighThreshold = -45;
            _50.WaterfallLowThreshold = -85;
            _50.BandwidthTrackBar.Value = 3382;
            _50.ANF.Checked = false;
            _50.NR.Checked = false;
            _50.NB1.Checked = false;
            _50.NB2.Checked = false;
            _50.Rate = 3;       
            _50.KKDevice = KKMethod.Ethernet;
            _50MHz.w3szendpoint1 = "192.168.1.109";
            
            
            
            // set all data accordingly for _144
            _144.SampleRate = 192000;
            _144MHz.FFTSize = 262144;
            _144.stepSize.Text = "10Hz";
            _144.Mode.Text = "USB";
            _144.VolumeTrackBar.Value = 8;
            _144.SafeTrackBarValueChange(43, _144.AGCTrackBar);
            _144.AGCSpeed.Text = "Fast";
            _144MHz.GridMax = -45;
            _144MHz.GridMin = -85;
            _144MHz.GridStep = 5;
            _144.WaterfallHighThreshold = -45;
            _144.WaterfallLowThreshold = -85;
            _144.BandwidthTrackBar.Value = 3382;
            _144.ANF.Checked = false;
            _144.NR.Checked = false;
            _144.NB1.Checked = false;
            _144.NB2.Checked = false;
            _144.Rate = 3;     
            _144.KKDevice = KKMethod.Ethernet;
            _144MHz.w3szendpoint1 = "192.168.1.37";
            
            
            
            // set all data accordingly for _222
            _222.SampleRate = 192000;
            _222MHz.FFTSize = 262144;
            _222.stepSize.Text = "10Hz";
            _222.Mode.Text = "USB";
            _222.VolumeTrackBar.Value = 8;
            _222.SafeTrackBarValueChange(43, _222.AGCTrackBar);
            _222.AGCSpeed.Text = "Fast";
            _222MHz.GridMax = -45;
            _222MHz.GridMin = -85;
            _222MHz.GridStep = 5;
            Moving_Forms_Test._222MHz.color_scheme = "enhanced";
            _222.WaterfallHighThreshold = -45;
            _222.WaterfallLowThreshold = -85;
            _222.BandwidthTrackBar.Value = 3382;
            _222.ANF.Checked = false;
            _222.NR.Checked = false;
            _222.NB1.Checked = false;
            _222.NB2.Checked = false;
            _222.Rate = 3;      
            _222.KKDevice = KKMethod.Ethernet;
            _222MHz.w3szendpoint1 = "192.168.1.113";
                       
            // set all data accordingly for _432
            _432.SampleRate = 192000;
            _432MHz.FFTSize = 262144;
            _432.stepSize.Text = "10Hz";
            _432.Mode.Text = "USB";
            _432.VolumeTrackBar.Value = 8;
            _432.SafeTrackBarValueChange(43, _432.AGCTrackBar);
            _432.AGCSpeed.Text = "Fast";
            _432MHz.GridMax = -45;
            _432MHz.GridMin = -85;
            _432MHz.GridStep = 5;
            Moving_Forms_Test._432MHz.color_scheme = "enhanced";
            _432.WaterfallHighThreshold = -45;
            _432.WaterfallLowThreshold = -85;
            _432.BandwidthTrackBar.Value = 3382;
            _432.ANF.Checked = false;
            _432.NR.Checked = false;
            _432.NB1.Checked = false;
            _432.NB2.Checked = false;
            _432.Rate = 3;   
            _432.KKDevice = KKMethod.Ethernet;
            _432MHz.w3szendpoint1 = "192.168.1.149";
                       
            // set all data accordingly for _903
            _903.SampleRate = 192000;
            _903MHz.FFTSize = 262144;
            _903.stepSize.Text = "10Hz";
            _903.Mode.Text = "USB";
            _903.VolumeTrackBar.Value = 8;
            _903.SafeTrackBarValueChange(43, _903.AGCTrackBar);
            _903.AGCSpeed.Text = "Fast";
            _903MHz.GridMax = -45;
            _903MHz.GridMin = -85;
            _903MHz.GridStep = 5;
            Moving_Forms_Test._903MHz.color_scheme = "enhanced";
            _903.WaterfallHighThreshold = -45;
            _903.WaterfallLowThreshold = -85;
            _903.BandwidthTrackBar.Value = 3382;
            _903.ANF.Checked = false;
            _903.NR.Checked = false;
            _903.NB1.Checked = false;
            _903.NB2.Checked = false;
            _903.Rate = 3;    
            _903.KKDevice = KKMethod.Ethernet;
            _903MHz.w3szendpoint1 = "192.168.1.88";
                          
            // set all data accordingly for _1296
            _1296.SampleRate = 192000;
            _1296MHz.FFTSize = 262144;
            _1296.stepSize.Text = "10Hz";
            _1296.Mode.Text = "USB";
            _1296.VolumeTrackBar.Value = 8;
            _1296.SafeTrackBarValueChange(43, _1296.AGCTrackBar);
            _1296.AGCSpeed.Text = "Fast";
            _1296MHz.GridMax = -45;
            _1296MHz.GridMin = -85;
            _1296MHz.GridStep = 5;
            Moving_Forms_Test._1296MHz.color_scheme = "enhanced";
            _1296.WaterfallHighThreshold = -45;
            _1296.WaterfallLowThreshold = -85;
            _1296.BandwidthTrackBar.Value = 3382;
            _1296.ANF.Checked = false;
            _1296.NR.Checked = false;
            _1296.NB1.Checked = false;
            _1296.NB2.Checked = false;
            _1296.Rate = 3;       
            _1296.KKDevice = KKMethod.Ethernet;
            _1296MHz.w3szendpoint1 = "192.168.1.108";

    //        if (Properties.Settings.Default.HFChecked)
            {
                // set all data accordingly for _HF
                _HF.SampleRate = 192000;
                _HF.FFTSize = 262144;
                _HF.stepSize.Text = "10Hz";
                _HF.Mode.Text = "USB";
                _HF.VolumeTrackBar.Value = 8;
                _HF.SafeTrackBarValueChange(43, _HF.AGCTrackBar);
                _HF.AGCSpeed.Text = "Fast";
                _HF.GridMax = -45;
                _HF.GridMin = -85;
                _HF.GridStep = 5;
                Moving_Forms_Test._HF.color_scheme = "enhanced";
                _HF.WaterfallHighThreshold = -45;
                _HF.WaterfallLowThreshold = -85;
                _HF.BandwidthTrackBar.Value = 3382;
                _HF.ANF.Checked = false;
                _HF.NR.Checked = false;
                _HF.NB1.Checked = false;
                _HF.NB2.Checked = false;
                _HF.Rate = 3;
                _HF.KKDevice = KKMethod.Ethernet;
                _HF.w3szendpoint1 = "192.168.10.55";
            }
  
   //GLOBAL VARIABLES BELOW THAT DO NOT NEED TO BE STORED FOR EACH 
   //BAND WINDOW         
            Globals.color_scheme = "enhanced";
            Globals.xWidth = 590;
            Micro.set_frequency.Value = 28105000;
            Micro.xvtr_frequency_50 = 50125000;
            Micro.xvtr_frequency_144 = 144200000;
            Micro.xvtr_frequency_222 = 222100000;
            Micro.xvtr_frequency_432 = 432100000;
            Micro.xvtr_frequency_903 = 902100000;
            Micro.xvtr_frequency_1296 = 1296100000;
            Micro.xvtr_frequency_2304 = 2304100000;
            Micro.xvtr_frequency_3456 = 3456100000;
            Micro.xvtr_frequency_5760 = 5760100000;
            Micro.xvtr_frequency_10368 = 10368100000;
            Micro.xvtr_frequency_24192 = 24192100000;
   //         if (Properties.Settings.Default.HFChecked)
            {
                _HF.set_frequency_160 = 1800000;
                _HF.set_frequency_80 = 3800000;
                _HF.set_frequency_40 = 7100000;
                _HF.set_frequency_20 = 14100000;
                _HF.set_frequency_15 = 21100000;
                _HF.set_frequency_10 = 28100000;
                _HF.set_frequency_12 = 24940000;
                _HF.set_frequency_30 = 10120000;
                _HF.set_frequency_6 = 54100000;
                _HF.set_frequency_GC = 10000000;
                _HF.set_frequency_17 = 18100000;
                _HF.BandText = "40m";

            _HF.Preamp_160 = false;
            _HF.Preamp_80 = false;
            _HF.Preamp_40 = false;
            _HF.Preamp_30 = false;
            _HF.Preamp_20 = false;
            _HF.Preamp_17 = false;
            _HF.Preamp_15 = false;
            _HF.Preamp_12 = false;
            _HF.Preamp_10 = false;
            _HF.Preamp_6 = false;
            _HF.Preamp_GC = false;
            _HF.Drive = "50";
            _HF.Gain160m = 50;
            _HF.Gain80m = 50;
            _HF.Gain40m = 50;
            _HF.Gain30m = 50;
            _HF.Gain20m = 50;
            _HF.Gain17m = 50;
            _HF.Gain15m = 50;
            _HF.Gain12m = 50;
            _HF.Gain10m = 50;
            _HF.Gain6m = 50;
            }
            Globals.microband = "2304";          
            MicroMHz.Preamp_50 = false;
            MicroMHz.Preamp_144 = false;
            MicroMHz.Preamp_222 = false;
            MicroMHz.Preamp_432 = false;
            MicroMHz.Preamp_903 = false;
            MicroMHz.Preamp_1296 = false;
            MicroMHz.Preamp_2304 = false;
            MicroMHz.Preamp_3456 = false;
            MicroMHz.Preamp_5760 = false;
            MicroMHz.Preamp_10368 = false;
            MicroMHz.Preamp_24192 = false;

            MicroMHz.Drive50 = 50;
            MicroMHz.Drive144 = 50;
            MicroMHz.Drive222 = 50;
            MicroMHz.Drive432 = 50;
            MicroMHz.Drive903 = 50;
            MicroMHz.Drive1296 = 50;
            MicroMHz.Drive2304 = 50;
            MicroMHz.Drive3456 = 50;
            MicroMHz.Drive5760 = 50;
            MicroMHz.Drive10368 = 50;
            MicroMHz.Drive24192 = 50;

            MicroMHz.Gain50MHz = 50;
            MicroMHz.Gain144MHz = 50;
            MicroMHz.Gain222MHz = 50;
            MicroMHz.Gain432MHz = 50;
            MicroMHz.Gain903MHz = 50;
            MicroMHz.Gain1296MHz = 50;
            MicroMHz.Gain2304MHz = 50;
            MicroMHz.Gain3456MHz = 50;
            MicroMHz.Gain5760MHz = 50;
            MicroMHz.Gain10368MHz = 50;
            MicroMHz.Gain24192MHz = 50;

            xvtr_frequency_50_minimum = 50000000;  // low band limit
            xvtr_frequency_50_maximum = 54000000;  // high band limit
            xvtr_frequency_144_minimum = 144000000;  // low band limit
            xvtr_frequency_144_maximum = 148000000;  // high band limit
            xvtr_frequency_222_minimum = 222000000;  // low band limit
            xvtr_frequency_222_maximum = 225000000;  // high band limit
            xvtr_frequency_432_minimum = 432000000;  // low band limit
            xvtr_frequency_432_maximum = 436000000;  // high band limit
            xvtr_frequency_903_minimum = 902000000;  // low band limit
            xvtr_frequency_903_maximum = 906000000;  // high band limit
            xvtr_frequency_1296_minimum = 1296000000;  // low band limit
            xvtr_frequency_1296_maximum = 1300000000;  // high band limit
            xvtr_frequency_2304_minimum = 2304000000;  // low band limit
            xvtr_frequency_2304_maximum = 2308000000;  // high band limit
            xvtr_frequency_3456_minimum = 3456000000;  // low band limit
            xvtr_frequency_3456_maximum = 3460000000;  // high band limit
            xvtr_frequency_5760_minimum = 5760000000;  // low band limit
            xvtr_frequency_5760_maximum = 5764000000;  // high band limit
            xvtr_frequency_10368_minimum = 10368000000;  // low band limit
            xvtr_frequency_10368_maximum = 10372000000;  // high band limit
            xvtr_frequency_24192_minimum = 24192000000;  // low band limit
            xvtr_frequency_24192_maximum = 24196000000;  // high band limit
            frequency_160_minimum = 1800000;  // low band limit
            frequency_160_maximum = 2000000;  // high band limit
            frequency_80_minimum = 3500000;  // low band limit
            frequency_80_maximum = 4000000;  // high band limit
            frequency_40_minimum = 7000000;  // low band limit
            frequency_40_maximum = 7300000;  // high band limit
            frequency_30_minimum = 10100000;  // low band limit
            frequency_30_maximum = 10200000;  // high band limit
            frequency_20_minimum = 14000000;  // low band limit
            frequency_20_maximum = 14350000;  // high band limit
            frequency_17_minimum = 18068000;  // low band limit
            frequency_17_maximum = 18168000;  // high band limit
            frequency_15_minimum = 21000000;  // low band limit
            frequency_15_maximum = 21450000;  // high band limit
            frequency_12_minimum = 24880000;  // low band limit
            frequency_12_maximum = 24980000;  // high band limit
            frequency_10_minimum = 28000000;  // low band limit
            frequency_10_maximum = 29700000;  // high band limit
            frequency_6_minimum = 50000000;  // low band limit
            frequency_6_maximum = 55000000;  // high band limit
            frequency_GC_minimum = 00000000;  // low band limit
            frequency_GC_maximum = 55000000;  // high band limit
            
   //         Properties.Settings.Default.N1MMCOM = "COM15";
   //         Properties.Settings.Default.N1MMCOMLiaison = "COM17";

            // create the file
            WriteKKCSV(KKCSVName);
        }

        private void WriteKKCSV(string KKCSVName)
        {
            // save the current settings to Moving_Forms_Test.csv
            List<string> lines = new List<string>();        // create a List<string> to hold all the output lines

            // each line of the output file, in output order for micro
            lines.Add("Micro KKDevice," + ((int)Micro.KKDevice).ToString());
            lines.Add("Micro Band," + Globals.microband);
            lines.Add("Micro Sample Rate," + Micro.SampleRate);
            lines.Add("Micro FFTSize," + MicroMHz.FFTSize);
            lines.Add("Micro Step Size," + Micro.stepSize.Text);
            lines.Add("Micro Mode," + Micro.Mode.Text);
            lines.Add("Micro Volume," + Micro.VolumeTrackBar.Value);
            lines.Add("Micro Bandwidth," + Micro.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("Micro ANF," + (Micro.ANF.Checked).ToString());
            lines.Add("Micro NR," + (Micro.NR.Checked).ToString());
            lines.Add("Micro NB1," + (Micro.NB1.Checked).ToString());
            lines.Add("Micro NB2," + (Micro.NB2.Checked).ToString());
            lines.Add("Micro Rate," + Micro.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("Micro Bandscope Grid Max," + MicroMHz.GridMax.ToString(nfi));
            lines.Add("Micro Bandscope Grid Min," + MicroMHz.GridMin.ToString(nfi));
            lines.Add("Micro Bandscope Grid Step," + MicroMHz.GridStep.ToString(nfi));
            lines.Add("Micro Waterfall Palette," + Moving_Forms_Test.MicroMHz.color_scheme);

            lines.Add("Micro AGC Speed," + Micro.AGCSpeed.Text);
            lines.Add("Micro AGC Max Gain," + MicroMHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("Micro WaterfallHigh," + Micro.WaterfallHighThreshold.ToString(nfi));
            lines.Add("Micro WaterfallLow," + Micro.WaterfallLowThreshold.ToString(nfi));
            lines.Add("Micro WaterFall AGC," + MicroMHz.WaterfallAGC.ToString(nfi));

            lines.Add("Micro Squelch level," + Micro.Squelch_level.Value.ToString(nfi));
            lines.Add("Micro Bandscope Squelch," + Micro.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("Micro Filter Squelch," + Micro.Filter_squelch.Checked.ToString(nfi));


            lines.Add("Micro Drive Level," + Micro.DriveLevel.Value.ToString(nfi));  //will need to make per band for Micro
            lines.Add("Micro Speech Processor," + Micro.chkClipper.Checked.ToString(nfi));

            lines.Add("Micro Mic Gain," + Micro.MicrophoneGain.Value.ToString(nfi));
            lines.Add("Micro Processor Gain," + Micro.ProcessorGain.Value.ToString(nfi));
            lines.Add("Micro Noise Gate," + Micro.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("Micro Noise Gate Level," + Micro.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpointGHz," + MicroMHz.w3szendpoint1);
            lines.Add("Micro Full Duplex," + MicroMHz.Duplex.ToString(nfi));
            lines.Add("Micro Only Tx on PTT," + MicroMHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("Micro Tune Level," + MicroMHz.TuneLevel.ToString(nfi));
            lines.Add("Micro DelayRF," + MicroMHz.DelayRF.ToString(nfi));
            lines.Add("Micro DelayPTT," + MicroMHz.DelayPTT.ToString(nfi));
            lines.Add("Micro FM deviation," + MicroMHz.FM_deviation.ToString(nfi));
            lines.Add("Micro Tx Filter High," + MicroMHz.TxFilterHigh.ToString(nfi));
            lines.Add("Micro Tx Filter Low," + MicroMHz.TxFilterLow.ToString(nfi));

            lines.Add("Micro Zoom100," + Micro.Zoom100.Checked.ToString(nfi));
            lines.Add("Micro Zoom75," + Micro.Zoom75.Checked.ToString(nfi));
            lines.Add("Micro Zoom50," + Micro.Zoom50.Checked.ToString(nfi));
            lines.Add("Micro Zoom25," + Micro.Zoom25.Checked.ToString(nfi));
            lines.Add("Micro Track Bar," + Micro.Zoom_Track_Bar.Value.ToString(nfi));

            lines.Add("Enable Micro Band Data," + MicroMHz.EnableBandData.ToString(nfi));
            lines.Add("LPT Address," + MicroMHz.LPT_Addr);

                     
            // // each line of the output file, in output order for _50
            lines.Add("_50 KKDevice," + ((int)_50.KKDevice).ToString());
            lines.Add("_50 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_50 Sample Rate," + _50.SampleRate);
            lines.Add("_50 FFTSize," + _50MHz.FFTSize);
            lines.Add("_50 Step Size," + _50.stepSize.Text);
            lines.Add("_50 Mode," + _50.Mode.Text);
            lines.Add("_50 Volume," + _50.VolumeTrackBar.Value);
            lines.Add("_50 Bandwidth," + _50.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_50 ANF," + (_50.ANF.Checked).ToString());
            lines.Add("_50 NR," + (_50.NR.Checked).ToString());
            lines.Add("_50 NB1," + (_50.NB1.Checked).ToString());
            lines.Add("_50 NB2," + (_50.NB2.Checked).ToString());
            lines.Add("_50 Rate," + _50.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_50 Bandscope Grid Max," + _50MHz.GridMax.ToString(nfi));
            lines.Add("_50 Bandscope Grid Min," + _50MHz.GridMin.ToString(nfi));
            lines.Add("_50 Bandscope Grid Step," + _50MHz.GridStep.ToString(nfi));
            lines.Add("_50 Waterfall Palette," + Moving_Forms_Test._50MHz.color_scheme);

            lines.Add("_50 AGC Speed," + _50.AGCSpeed.Text);
            lines.Add("_50 AGC Max Gain," + _50MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_50 WaterfallHigh," + _50.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_50 WaterfallLow," + _50.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_50 WaterFall AGC," + _50MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_50 Squelch level," + _50.Squelch_level.Value.ToString(nfi));
            lines.Add("_50 Bandscope Squelch," + _50.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_50 Filter Squelch," + _50.Filter_squelch.Checked.ToString(nfi));
            
            lines.Add("_50 Drive Level," + _50.DriveLevel.Value.ToString(nfi));  //will need to make per band for _50
            lines.Add("_50 Speech Processor," + _50.chkClipper.Checked.ToString(nfi));

            lines.Add("_50 Mic Gain," + _50.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_50 Processor Gain," + _50.ProcessorGain.Value.ToString(nfi));
            lines.Add("_50 Noise Gate," + _50.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_50 Noise Gate Level," + _50.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint50," + _50MHz.w3szendpoint1);
            lines.Add("_50 Full Duplex," + _50MHz.Duplex.ToString(nfi));
            lines.Add("_50 Only Tx on PTT," + _50MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_50 Tune Level," + _50MHz.TuneLevel.ToString(nfi));
            lines.Add("_50 Tx Filter High," + _50MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_50 Tx Filter Low," + _50MHz.TxFilterLow.ToString(nfi));

            lines.Add("_50 Zoom100," + _50.Zoom100.Checked.ToString(nfi));
            lines.Add("_50 Zoom75," + _50.Zoom75.Checked.ToString(nfi));
            lines.Add("_50 Zoom50," + _50.Zoom50.Checked.ToString(nfi));
            lines.Add("_50 Zoom25," + _50.Zoom25.Checked.ToString(nfi));
            lines.Add("_50 Track Bar," + _50.Zoom_Track_Bar.Value.ToString(nfi));
            
            // // each line of the output file, in output order for _144
            lines.Add("_144 KKDevice," + ((int)_144.KKDevice).ToString());
            lines.Add("_144 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_144 Sample Rate," + _144.SampleRate);
            lines.Add("_144 FFTSize," + _144MHz.FFTSize);
            lines.Add("_144 Step Size," + _144.stepSize.Text);
            lines.Add("_144 Mode," + _144.Mode.Text);
            lines.Add("_144 Volume," + _144.VolumeTrackBar.Value);
            lines.Add("_144 Bandwidth," + _144.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_144 ANF," + (_144.ANF.Checked).ToString());
            lines.Add("_144 NR," + (_144.NR.Checked).ToString());
            lines.Add("_144 NB1," + (_144.NB1.Checked).ToString());
            lines.Add("_144 NB2," + (_144.NB2.Checked).ToString());
            lines.Add("_144 Rate," + _144.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_144 Bandscope Grid Max," + _144MHz.GridMax.ToString(nfi));
            lines.Add("_144 Bandscope Grid Min," + _144MHz.GridMin.ToString(nfi));
            lines.Add("_144 Bandscope Grid Step," + _144MHz.GridStep.ToString(nfi));

            lines.Add("_144 AGC Speed," + _144.AGCSpeed.Text);
            lines.Add("_144 AGC Max Gain," + _144MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_144 WaterfallHigh," + _144.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_144 WaterfallLow," + _144.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_144 WaterFall AGC," + _144MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_144 Squelch level," + _144.Squelch_level.Value.ToString(nfi));
            lines.Add("_144 Bandscope Squelch," + _144.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_144 Filter Squelch," + _144.Filter_squelch.Checked.ToString(nfi));


            lines.Add("_144 Drive Level," + _144.DriveLevel.Value.ToString(nfi));  //will need to make per band for _144
            lines.Add("_144 Speech Processor," + _144.chkClipper.Checked.ToString(nfi));

            lines.Add("_144 Mic Gain," + _144.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_144 Processor Gain," + _144.ProcessorGain.Value.ToString(nfi));
            lines.Add("_144 Noise Gate," + _144.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_144 Noise Gate Level," + _144.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint144," + _144MHz.w3szendpoint1);
            lines.Add("_144 Full Duplex," + _144MHz.Duplex.ToString(nfi));
            lines.Add("_144 Only Tx on PTT," + _144MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_144 Tune Level," + _144MHz.TuneLevel.ToString(nfi));
            lines.Add("_144 Tx Filter High," + _144MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_144 Tx Filter Low," + _144MHz.TxFilterLow.ToString(nfi));

            lines.Add("_144 Zoom100," + _144.Zoom100.Checked.ToString(nfi));
            lines.Add("_144 Zoom75," + _144.Zoom75.Checked.ToString(nfi));
            lines.Add("_144 Zoom50," + _144.Zoom50.Checked.ToString(nfi));
            lines.Add("_144 Zoom25," + _144.Zoom25.Checked.ToString(nfi));
            lines.Add("_144 Track Bar," + _144.Zoom_Track_Bar.Value.ToString(nfi));
            
            // // each line of the output file, in output order for _222
            lines.Add("_222 KKDevice," + ((int)_222.KKDevice).ToString());
            lines.Add("_222 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_222 Sample Rate," + _222.SampleRate);
            lines.Add("_222 FFTSize," + _222MHz.FFTSize);
            lines.Add("_222 Step Size," + _222.stepSize.Text);
            lines.Add("_222 Mode," + _222.Mode.Text);
            lines.Add("_222 Volume," + _222.VolumeTrackBar.Value);
            lines.Add("_222 Bandwidth," + _222.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_222 ANF," + (_222.ANF.Checked).ToString());
            lines.Add("_222 NR," + (_222.NR.Checked).ToString());
            lines.Add("_222 NB1," + (_222.NB1.Checked).ToString());
            lines.Add("_222 NB2," + (_222.NB2.Checked).ToString());
            lines.Add("_222 Rate," + _222.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_222 Bandscope Grid Max," + _222MHz.GridMax.ToString(nfi));
            lines.Add("_222 Bandscope Grid Min," + _222MHz.GridMin.ToString(nfi));
            lines.Add("_222 Bandscope Grid Step," + _222MHz.GridStep.ToString(nfi));
            lines.Add("_222 Waterfall Palette," + Moving_Forms_Test._222MHz.color_scheme);

            lines.Add("_222 AGC Speed," + _222.AGCSpeed.Text);
            lines.Add("_222 AGC Max Gain," + _222MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_222 WaterfallHigh," + _222.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_222 WaterfallLow," + _222.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_222 WaterFall AGC," + _222MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_222 Squelch level," + _222.Squelch_level.Value.ToString(nfi));
            lines.Add("_222 Bandscope Squelch," + _222.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_222 Filter Squelch," + _222.Filter_squelch.Checked.ToString(nfi));
            
            lines.Add("_222 Drive Level," + _222.DriveLevel.Value.ToString(nfi));  //will need to make per band for _222
            lines.Add("_222 Speech Processor," + _222.chkClipper.Checked.ToString(nfi));

            lines.Add("_222 Mic Gain," + _222.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_222 Processor Gain," + _222.ProcessorGain.Value.ToString(nfi));
            lines.Add("_222 Noise Gate," + _222.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_222 Noise Gate Level," + _222.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint222," + _222MHz.w3szendpoint1);
            lines.Add("_222 Full Duplex," + _222MHz.Duplex.ToString(nfi));
            lines.Add("_222 Only Tx on PTT," + _222MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_222 Tune Level," + _222MHz.TuneLevel.ToString(nfi));
            lines.Add("_222 Tx Filter High," + _222MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_222 Tx Filter Low," + _222MHz.TxFilterLow.ToString(nfi));

            lines.Add("_222 Zoom100," + _222.Zoom100.Checked.ToString(nfi));
            lines.Add("_222 Zoom75," + _222.Zoom75.Checked.ToString(nfi));
            lines.Add("_222 Zoom50," + _222.Zoom50.Checked.ToString(nfi));
            lines.Add("_222 Zoom25," + _222.Zoom25.Checked.ToString(nfi));
            lines.Add("_222 Track Bar," + _222.Zoom_Track_Bar.Value.ToString(nfi));
                    
            
            // // each line of the output file, in output order for _432
            lines.Add("_432 KKDevice," + ((int)_432.KKDevice).ToString());
            lines.Add("_432 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_432 Sample Rate," + _432.SampleRate);
            lines.Add("_432 FFTSize," + _432MHz.FFTSize);
            lines.Add("_432 Step Size," + _432.stepSize.Text);
            lines.Add("_432 Mode," + _432.Mode.Text);
            lines.Add("_432 Volume," + _432.VolumeTrackBar.Value);
            lines.Add("_432 Bandwidth," + _432.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_432 ANF," + (_432.ANF.Checked).ToString());
            lines.Add("_432 NR," + (_432.NR.Checked).ToString());
            lines.Add("_432 NB1," + (_432.NB1.Checked).ToString());
            lines.Add("_432 NB2," + (_432.NB2.Checked).ToString());
            lines.Add("_432 Rate," + _432.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_432 Bandscope Grid Max," + _432MHz.GridMax.ToString(nfi));
            lines.Add("_432 Bandscope Grid Min," + _432MHz.GridMin.ToString(nfi));
            lines.Add("_432 Bandscope Grid Step," + _432MHz.GridStep.ToString(nfi));
            lines.Add("_432 Waterfall Palette," + Moving_Forms_Test._432MHz.color_scheme);

            lines.Add("_432 AGC Speed," + _432.AGCSpeed.Text);
            lines.Add("_432 AGC Max Gain," + _432MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_432 WaterfallHigh," + _432.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_432 WaterfallLow," + _432.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_432 WaterFall AGC," + _432MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_432 Squelch level," + _432.Squelch_level.Value.ToString(nfi));
            lines.Add("_432 Bandscope Squelch," + _432.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_432 Filter Squelch," + _432.Filter_squelch.Checked.ToString(nfi));


            lines.Add("_432 Drive Level," + _432.DriveLevel.Value.ToString(nfi));  //will need to make per band for _432
            lines.Add("_432 Speech Processor," + _432.chkClipper.Checked.ToString(nfi));

            lines.Add("_432 Mic Gain," + _432.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_432 Processor Gain," + _432.ProcessorGain.Value.ToString(nfi));
            lines.Add("_432 Noise Gate," + _432.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_432 Noise Gate Level," + _432.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint432," + _432MHz.w3szendpoint1);
            lines.Add("_432 Full Duplex," + _432MHz.Duplex.ToString(nfi));
            lines.Add("_432 Only Tx on PTT," + _432MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_432 Tune Level," + _432MHz.TuneLevel.ToString(nfi));
            lines.Add("_432 Tx Filter High," + _432MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_432 Tx Filter Low," + _432MHz.TxFilterLow.ToString(nfi));

            lines.Add("_432 Zoom100," + _432.Zoom100.Checked.ToString(nfi));
            lines.Add("_432 Zoom75," + _432.Zoom75.Checked.ToString(nfi));
            lines.Add("_432 Zoom50," + _432.Zoom50.Checked.ToString(nfi));
            lines.Add("_432 Zoom25," + _432.Zoom25.Checked.ToString(nfi));
            lines.Add("_432 Track Bar," + _432.Zoom_Track_Bar.Value.ToString(nfi));
                
            // // each line of the output file, in output order for _903
            lines.Add("_903 KKDevice," + ((int)_903.KKDevice).ToString());
            lines.Add("_903 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_903 Sample Rate," + _903.SampleRate);
            lines.Add("_903 FFTSize," + _903MHz.FFTSize);
            lines.Add("_903 Step Size," + _903.stepSize.Text);
            lines.Add("_903 Mode," + _903.Mode.Text);
            lines.Add("_903 Volume," + _903.VolumeTrackBar.Value);
            lines.Add("_903 Bandwidth," + _903.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_903 ANF," + (_903.ANF.Checked).ToString());
            lines.Add("_903 NR," + (_903.NR.Checked).ToString());
            lines.Add("_903 NB1," + (_903.NB1.Checked).ToString());
            lines.Add("_903 NB2," + (_903.NB2.Checked).ToString());
            lines.Add("_903 Rate," + _903.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_903 Bandscope Grid Max," + _903MHz.GridMax.ToString(nfi));
            lines.Add("_903 Bandscope Grid Min," + _903MHz.GridMin.ToString(nfi));
            lines.Add("_903 Bandscope Grid Step," + _903MHz.GridStep.ToString(nfi));
            lines.Add("_903 Waterfall Palette," + Moving_Forms_Test._903MHz.color_scheme);

            lines.Add("_903 AGC Speed," + _903.AGCSpeed.Text);
            lines.Add("_903 AGC Max Gain," + _903MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_903 WaterfallHigh," + _903.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_903 WaterfallLow," + _903.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_903 WaterFall AGC," + _903MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_903 Squelch level," + _903.Squelch_level.Value.ToString(nfi));
            lines.Add("_903 Bandscope Squelch," + _903.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_903 Filter Squelch," + _903.Filter_squelch.Checked.ToString(nfi));
            
            lines.Add("_903 Drive Level," + _903.DriveLevel.Value.ToString(nfi));  //will need to make per band for _903
            lines.Add("_903 Speech Processor," + _903.chkClipper.Checked.ToString(nfi));

            lines.Add("_903 Mic Gain," + _903.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_903 Processor Gain," + _903.ProcessorGain.Value.ToString(nfi));
            lines.Add("_903 Noise Gate," + _903.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_903 Noise Gate Level," + _903.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint903," + _903MHz.w3szendpoint1);
            lines.Add("_903 Full Duplex," + _903MHz.Duplex.ToString(nfi));
            lines.Add("_903 Only Tx on PTT," + _903MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_903 Tune Level," + _903MHz.TuneLevel.ToString(nfi));
            lines.Add("_903 Tx Filter High," + _903MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_903 Tx Filter Low," + _903MHz.TxFilterLow.ToString(nfi));

            lines.Add("_903 Zoom100," + _903.Zoom100.Checked.ToString(nfi));
            lines.Add("_903 Zoom75," + _903.Zoom75.Checked.ToString(nfi));
            lines.Add("_903 Zoom50," + _903.Zoom50.Checked.ToString(nfi));
            lines.Add("_903 Zoom25," + _903.Zoom25.Checked.ToString(nfi));
            lines.Add("_903 Track Bar," + _903.Zoom_Track_Bar.Value.ToString(nfi));
            
            // // each line of the output file, in output order for _1296
            lines.Add("_1296 KKDevice," + ((int)_1296.KKDevice).ToString());
            lines.Add("_1296 Band," + Moving_Forms_Test.Globals.microband);
            lines.Add("_1296 Sample Rate," + _1296.SampleRate);
            lines.Add("_1296 FFTSize," + _1296MHz.FFTSize);
            lines.Add("_1296 Step Size," + _1296.stepSize.Text);
            lines.Add("_1296 Mode," + _1296.Mode.Text);
            lines.Add("_1296 Volume," + _1296.VolumeTrackBar.Value);
            lines.Add("_1296 Bandwidth," + _1296.BandwidthTrackBar.Value);
            // we need to store the following controls as true or false, first we convert from bool to a string
            lines.Add("_1296 ANF," + (_1296.ANF.Checked).ToString());
            lines.Add("_1296 NR," + (_1296.NR.Checked).ToString());
            lines.Add("_1296 NB1," + (_1296.NB1.Checked).ToString());
            lines.Add("_1296 NB2," + (_1296.NB2.Checked).ToString());
            lines.Add("_1296 Rate," + _1296.Rate.ToString());
             // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
            lines.Add("_1296 Bandscope Grid Max," + _1296MHz.GridMax.ToString(nfi));
            lines.Add("_1296 Bandscope Grid Min," + _1296MHz.GridMin.ToString(nfi));
            lines.Add("_1296 Bandscope Grid Step," + _1296MHz.GridStep.ToString(nfi));
            lines.Add("_1296 Waterfall Palette," + Moving_Forms_Test._1296MHz.color_scheme);

            lines.Add("_1296 AGC Speed," + _1296.AGCSpeed.Text);
            lines.Add("_1296 AGC Max Gain," + _1296MHz.AGCMaximumGainDB.ToString(nfi));

            lines.Add("_1296 WaterfallHigh," + _1296.WaterfallHighThreshold.ToString(nfi));
            lines.Add("_1296 WaterfallLow," + _1296.WaterfallLowThreshold.ToString(nfi));
            lines.Add("_1296 WaterFall AGC," + _1296MHz.WaterfallAGC.ToString(nfi));

            lines.Add("_1296 Squelch level," + _1296.Squelch_level.Value.ToString(nfi));
            lines.Add("_1296 Bandscope Squelch," + _1296.Bandscope_squelch.Checked.ToString(nfi));
            lines.Add("_1296 Filter Squelch," + _1296.Filter_squelch.Checked.ToString(nfi));


            lines.Add("_1296 Drive Level," + _1296.DriveLevel.Value.ToString(nfi));  
            lines.Add("_1296 Speech Processor," + _1296.chkClipper.Checked.ToString(nfi));

            lines.Add("_1296 Mic Gain," + _1296.MicrophoneGain.Value.ToString(nfi));
            lines.Add("_1296 Processor Gain," + _1296.ProcessorGain.Value.ToString(nfi));
            lines.Add("_1296 Noise Gate," + _1296.chkNoiseGate.Checked.ToString(nfi));
            lines.Add("_1296 Noise Gate Level," + _1296.NoiseGateLevel.Value.ToString(nfi));
            lines.Add("w3szendpoint1296," + _1296MHz.w3szendpoint1);
            lines.Add("_1296 Full Duplex," + _1296MHz.Duplex.ToString(nfi));
            lines.Add("_1296 Only Tx on PTT," + _1296MHz.OnlyTxOnPTT.ToString(nfi));
            lines.Add("_1296 Tune Level," + _1296MHz.TuneLevel.ToString(nfi));
            lines.Add("_1296 Tx Filter High," + _1296MHz.TxFilterHigh.ToString(nfi));
            lines.Add("_1296 Tx Filter Low," + _1296MHz.TxFilterLow.ToString(nfi));

            lines.Add("_1296 Zoom100," + _1296.Zoom100.Checked.ToString(nfi));
            lines.Add("_1296 Zoom75," + _1296.Zoom75.Checked.ToString(nfi));
            lines.Add("_1296 Zoom50," + _1296.Zoom50.Checked.ToString(nfi));
            lines.Add("_1296 Zoom25," + _1296.Zoom25.Checked.ToString(nfi));
            lines.Add("_1296 Track Bar," + _1296.Zoom_Track_Bar.Value.ToString(nfi));
            // // each line of the output file, in output order for _HF
   //         if (Properties.Settings.Default.HFChecked)
            {
                lines.Add("_HF KKDevice," + ((int)_HF.KKDevice).ToString());
                lines.Add("_HF Band," + Moving_Forms_Test.Globals.microband);
                lines.Add("_HF Sample Rate," + _HF.SampleRate);
                lines.Add("_HF FFTSize," + _HF.FFTSize);
                lines.Add("_HF Step Size," + _HF.stepSize.Text);
                lines.Add("_HF Mode," + _HF.Mode.Text);
                lines.Add("_HF Volume," + _HF.VolumeTrackBar.Value);
                lines.Add("_HF Bandwidth," + _HF.BandwidthTrackBar.Value);
                // we need to store the following controls as true or false, first we convert from bool to a string
                lines.Add("_HF ANF," + (_HF.ANF.Checked).ToString());
                lines.Add("_HF NR," + (_HF.NR.Checked).ToString());
                lines.Add("_HF NB1," + (_HF.NB1.Checked).ToString());
                lines.Add("_HF NB2," + (_HF.NB2.Checked).ToString());
                lines.Add("_HF Rate," + _HF.Rate.ToString());
                // end of original Moving_Forms_Test.csv file. beginning of values that LookupKKCSVValue should be used on
                lines.Add("_HF Bandscope Grid Max," + Moving_Forms_Test._HF.GridMax.ToString(nfi));
                lines.Add("_HF Bandscope Grid Min," + Moving_Forms_Test._HF.GridMin.ToString(nfi));
                lines.Add("_HF Bandscope Grid Step," + Moving_Forms_Test._HF.GridStep.ToString(nfi));
                lines.Add("_HF Waterfall Palette," + Moving_Forms_Test._HF.color_scheme);

                lines.Add("_HF AGC Speed," + _HF.AGCSpeed.Text);
                lines.Add("_HF AGC Max Gain," + Moving_Forms_Test._HF.AGCMaximumGainDB.ToString(nfi));

                lines.Add("_HF WaterfallHigh," + _HF.WaterfallHighThreshold.ToString(nfi));
                lines.Add("_HF WaterfallLow," + _HF.WaterfallLowThreshold.ToString(nfi));
                lines.Add("_HF WaterFall AGC," + Moving_Forms_Test._HF.WaterfallAGC.ToString(nfi));

                lines.Add("_HF Squelch level," + _HF.Squelch_level.Value.ToString(nfi));
                lines.Add("_HF Bandscope Squelch," + _HF.Bandscope_squelch.Checked.ToString(nfi));
                lines.Add("_HF Filter Squelch," + _HF.Filter_squelch.Checked.ToString(nfi));
                
                lines.Add("_HF Drive Level," + _HF.DriveLevel.Value.ToString(nfi));  //will need to make per band for _HF
                lines.Add("_HF Speech Processor," + _HF.chkClipper.Checked.ToString(nfi));

                lines.Add("_HF Mic Gain," + _HF.MicrophoneGain.Value.ToString(nfi));
                lines.Add("_HF Processor Gain," + _HF.ProcessorGain.Value.ToString(nfi));
                lines.Add("_HF Noise Gate," + _HF.chkNoiseGate.Checked.ToString(nfi));
                lines.Add("_HF Noise Gate Level," + _HF.NoiseGateLevel.Value.ToString(nfi));
                lines.Add("w3szendpointHF," + Moving_Forms_Test._HF.w3szendpoint1);
                lines.Add("_HF Full Duplex," + Moving_Forms_Test._HF.Duplex.ToString(nfi));
                lines.Add("_HF Only Tx on PTT," + Moving_Forms_Test._HF.OnlyTxOnPTT.ToString(nfi));
                lines.Add("_HF Tune Level," + Moving_Forms_Test._HF.TuneLevel.ToString(nfi));
                lines.Add("_HF Tx Filter High," + Moving_Forms_Test._HF.TxFilterHigh.ToString(nfi));
                lines.Add("_HF Tx Filter Low," + Moving_Forms_Test._HF.TxFilterLow.ToString(nfi));

                lines.Add("_HF Zoom100," + _HF.Zoom100.Checked.ToString(nfi));
                lines.Add("_HF Zoom75," + _HF.Zoom75.Checked.ToString(nfi));
                lines.Add("_HF Zoom50," + _HF.Zoom50.Checked.ToString(nfi));
                lines.Add("_HF Zoom25," + _HF.Zoom25.Checked.ToString(nfi));
                lines.Add("_HF Track Bar," + _HF.Zoom_Track_Bar.Value.ToString(nfi));
            }
   //GLOBAL VARIABLES BELOW THAT DO NOT NEED TO BE STORED FOR EACH 
   //BAND WINDOW         

            lines.Add("Waterfall Palette," + Globals.color_scheme);
            lines.Add("xWidth," + Globals.xWidth.ToString(nfi));
            if (Micro.xvtr_frequency_50 > xvtr_frequency_50_minimum)
            {
                lines.Add("Last Freq 50MHz," + Micro.xvtr_frequency_50);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_50_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_50);
                lines.Add("Last Freq 50MHz," + 50100000);
            }
            if (Micro.xvtr_frequency_144 > xvtr_frequency_144_minimum)
            {
                lines.Add("Last Freq 144MHz," + Micro.xvtr_frequency_144);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_144_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_144);
                lines.Add("Last Freq 144MHz," + 144200000);
            }
            if (Micro.xvtr_frequency_222 > xvtr_frequency_222_minimum)
            {
                lines.Add("Last Freq 222MHz," + Micro.xvtr_frequency_222);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_222_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_222);
                lines.Add("Last Freq 222MHz," + 222100000);
            }
            if (Micro.xvtr_frequency_432 > xvtr_frequency_432_minimum)
            { 
                lines.Add("Last Freq 432MHz," + Micro.xvtr_frequency_432);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_432_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_432);
                lines.Add("Last Freq 432MHz," + 432100000);
            }

            if (Micro.xvtr_frequency_903 > xvtr_frequency_903_minimum)
            {
                lines.Add("Last Freq 903MHz," + Micro.xvtr_frequency_903);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_903_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_903);
                lines.Add("Last Freq 903MHz," + 903100000);
            }
            if (Micro.xvtr_frequency_1296 > xvtr_frequency_1296_minimum)
            {
                lines.Add("Last Freq 1296MHz," + Micro.xvtr_frequency_1296);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_1296_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_1296);
                lines.Add("Last Freq 1296MHz," + 1296100000);
            }
            if (Micro.xvtr_frequency_2304 > xvtr_frequency_2304_minimum)
            {
                lines.Add("Last Freq 2304MHz," + Micro.xvtr_frequency_2304);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_2304_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_2304);
                lines.Add("Last Freq 2304MHz," + 2304100000);
            }
            if (Micro.xvtr_frequency_3456 > xvtr_frequency_3456_minimum)
            {
                lines.Add("Last Freq 3456MHz," + Micro.xvtr_frequency_3456);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_3456_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_3456);
                lines.Add("Last Freq 3456MHz," + 3456100000);
            }
            if (Micro.xvtr_frequency_5760 > xvtr_frequency_5760_minimum)
            {
                lines.Add("Last Freq 5760MHz," + Micro.xvtr_frequency_5760);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_5760_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_5760);
                lines.Add("Last Freq 5760MHz," + 5760100000);
            }
            if (Micro.xvtr_frequency_10368 > xvtr_frequency_10368_minimum)
            {
                lines.Add("Last Freq 10368MHz," + Micro.xvtr_frequency_10368);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " +  xvtr_frequency_10368_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_10368);
                lines.Add("Last Freq 10368MHz," + 10368100000);
            }
            if (Micro.xvtr_frequency_24192 > xvtr_frequency_24192_minimum)
            {
                lines.Add("Last Freq 24192MHz," + Micro.xvtr_frequency_24192);
            }
            else
            {
                MessageBox.Show("Transverter frequency is lower than " + xvtr_frequency_24192_minimum.ToString() + ".  Xvtr frequency is " + Micro.xvtr_frequency_24192);
                lines.Add("Last Freq 24192MHz," + 24192100000);
            }
            //         if (Properties.Settings.Default.HFChecked)
            {
                lines.Add("Last Freq 160," + _HF.set_frequency_160);
                lines.Add("Last Freq 80," + _HF.set_frequency_80);
                lines.Add("Last Freq 40," + _HF.set_frequency_40);
                lines.Add("Last Freq 30," + _HF.set_frequency_30);
                lines.Add("Last Freq 20," + _HF.set_frequency_20);
                lines.Add("Last Freq 17," + _HF.set_frequency_17);
                lines.Add("Last Freq 15," + _HF.set_frequency_15);
                lines.Add("Last Freq 12," + _HF.set_frequency_12);
                lines.Add("Last Freq 10," + _HF.set_frequency_10);
                lines.Add("Last Freq 6," + _HF.set_frequency_6);
                lines.Add("Last Freq GC," + _HF.set_frequency_GC);
                lines.Add("_HF Last Freq," + _HF.set_frequency.Value);
                lines.Add("Micro Band," + Globals.microband);
                lines.Add("HF Band," + _HF.BandText);
                lines.Add("Preamp 160," + Moving_Forms_Test._HF.Preamp_160.ToString());
                lines.Add("Preamp 80," + Moving_Forms_Test._HF.Preamp_80.ToString());
                lines.Add("Preamp 40," + Moving_Forms_Test._HF.Preamp_40.ToString());
                lines.Add("Preamp 30," + Moving_Forms_Test._HF.Preamp_30.ToString());
                lines.Add("Preamp 20," + Moving_Forms_Test._HF.Preamp_20.ToString());
                lines.Add("Preamp 17," + Moving_Forms_Test._HF.Preamp_17.ToString());
                lines.Add("Preamp 15," + Moving_Forms_Test._HF.Preamp_15.ToString());
                lines.Add("Preamp 12," + Moving_Forms_Test._HF.Preamp_12.ToString());
                lines.Add("Preamp 10," + Moving_Forms_Test._HF.Preamp_10.ToString());
                lines.Add("Preamp 6," + Moving_Forms_Test._HF.Preamp_6.ToString());
                lines.Add("Preamp GC," + Moving_Forms_Test._HF.Preamp_GC.ToString());
                lines.Add("Gain 160," + Moving_Forms_Test._HF.Gain160m.ToString());
                lines.Add("Gain 80," + Moving_Forms_Test._HF.Gain80m.ToString());
                lines.Add("Gain 40," + Moving_Forms_Test._HF.Gain40m.ToString());
                lines.Add("Gain 30," + Moving_Forms_Test._HF.Gain30m.ToString());
                lines.Add("Gain 20," + Moving_Forms_Test._HF.Gain20m.ToString());
                lines.Add("Gain 17," + Moving_Forms_Test._HF.Gain17m.ToString());
                lines.Add("Gain 15," + Moving_Forms_Test._HF.Gain15m.ToString());
                lines.Add("Gain 12," + Moving_Forms_Test._HF.Gain12m.ToString());
                lines.Add("Gain 10," + Moving_Forms_Test._HF.Gain10m.ToString());
                lines.Add("Gain 6," + Moving_Forms_Test._HF.Gain6m.ToString());
                lines.Add("Drive HF," + _HF.Drive.ToString());
            }
           // save the preamp setting for each band
            lines.Add("Preamp 50," + MicroMHz.Preamp_50.ToString());
            lines.Add("Preamp 144," + MicroMHz.Preamp_144.ToString());
            lines.Add("Preamp 222," + MicroMHz.Preamp_222.ToString());
            lines.Add("Preamp 432," + MicroMHz.Preamp_432.ToString());
            lines.Add("Preamp 903," + MicroMHz.Preamp_903.ToString());
            lines.Add("Preamp 1296," + MicroMHz.Preamp_1296.ToString());
            lines.Add("Preamp 2304," + MicroMHz.Preamp_2304.ToString());
            lines.Add("Preamp 3456," + MicroMHz.Preamp_3456.ToString());
            lines.Add("Preamp 5760," + MicroMHz.Preamp_5760.ToString());
            lines.Add("Preamp 10368," + MicroMHz.Preamp_10368.ToString());
            lines.Add("Preamp 24192," + MicroMHz.Preamp_24192.ToString());
            // save the Drive setting for each band
            lines.Add("Drive 50," + MicroMHz.Drive50.ToString());
            lines.Add("Drive 144," + MicroMHz.Drive144.ToString());
            lines.Add("Drive 222," + MicroMHz.Drive222.ToString());
            lines.Add("Drive 432," + MicroMHz.Drive432.ToString());
            lines.Add("Drive 903," + MicroMHz.Drive903.ToString());
            lines.Add("Drive 1296," + MicroMHz.Drive1296.ToString());
            lines.Add("Drive 2304," + MicroMHz.Drive2304.ToString());
            lines.Add("Drive 3456," + MicroMHz.Drive3456.ToString());
            lines.Add("Drive 5760," + MicroMHz.Drive5760.ToString());
            lines.Add("Drive 10368," + MicroMHz.Drive10368.ToString());
            lines.Add("Drive 24192," + MicroMHz.Drive24192.ToString());
            // save the Gain setting for each band
            lines.Add("Gain 50," + MicroMHz.Gain50MHz.ToString());
            lines.Add("Gain 144," + MicroMHz.Gain144MHz.ToString());
            lines.Add("Gain 222," + MicroMHz.Gain222MHz.ToString());
            lines.Add("Gain 432," + MicroMHz.Gain432MHz.ToString());
            lines.Add("Gain 903," + MicroMHz.Gain903MHz.ToString());
            lines.Add("Gain 1296," + MicroMHz.Gain1296MHz.ToString());
            lines.Add("Gain 2304," + MicroMHz.Gain2304MHz.ToString());
            lines.Add("Gain 3456," + MicroMHz.Gain3456MHz.ToString());
            lines.Add("Gain 5760," + MicroMHz.Gain5760MHz.ToString());
            lines.Add("Gain 10368," + MicroMHz.Gain10368MHz.ToString());
            lines.Add("Gain 24192," + MicroMHz.Gain24192MHz.ToString());

            lines.Add("XVTR 50 MHz minimum frequency," + xvtr_frequency_50_minimum.ToString());
            lines.Add("XVTR 50 MHz maximum frequency," + xvtr_frequency_50_maximum.ToString());
            lines.Add("XVTR 144 MHz minimum frequency," + xvtr_frequency_144_minimum.ToString());
            lines.Add("XVTR 144 MHz maximum frequency," + xvtr_frequency_144_maximum.ToString());
            lines.Add("XVTR 222 MHz minimum frequency," + xvtr_frequency_222_minimum.ToString());
            lines.Add("XVTR 222 MHz maximum frequency," + xvtr_frequency_222_maximum.ToString());
            lines.Add("XVTR 432 MHz minimum frequency," + xvtr_frequency_432_minimum.ToString());
            lines.Add("XVTR 432 MHz maximum frequency," + xvtr_frequency_432_maximum.ToString());
            lines.Add("XVTR 903 MHz minimum frequency," + xvtr_frequency_903_minimum.ToString());
            lines.Add("XVTR 903 MHz maximum frequency," + xvtr_frequency_903_maximum.ToString());
            lines.Add("XVTR 1296 MHz minimum frequency," + xvtr_frequency_1296_minimum.ToString());
            lines.Add("XVTR 1296 MHz maximum frequency," + xvtr_frequency_1296_maximum.ToString());
            lines.Add("XVTR 2304 MHz minimum frequency," + xvtr_frequency_2304_minimum.ToString());
            lines.Add("XVTR 2304 MHz maximum frequency," + xvtr_frequency_2304_maximum.ToString());
            lines.Add("XVTR 3456 MHz minimum frequency," + xvtr_frequency_3456_minimum.ToString());
            lines.Add("XVTR 3456 MHz maximum frequency," + xvtr_frequency_3456_maximum.ToString());
            lines.Add("XVTR 5760 MHz minimum frequency," + xvtr_frequency_5760_minimum.ToString());
            lines.Add("XVTR 5760 MHz maximum frequency," + xvtr_frequency_5760_maximum.ToString());
            lines.Add("XVTR 10368 MHz minimum frequency," + xvtr_frequency_10368_minimum.ToString());
            lines.Add("XVTR 10368 MHz maximum frequency," + xvtr_frequency_10368_maximum.ToString());
            lines.Add("XVTR 24192 MHz minimum frequency," + xvtr_frequency_24192_minimum.ToString());
            lines.Add("XVTR 24192 MHz maximum frequency," + xvtr_frequency_24192_maximum.ToString());
            lines.Add("XVTR 160 minimum frequency," + frequency_160_minimum.ToString());
            lines.Add("XVTR 160 maximum frequency," + frequency_160_maximum.ToString());
            lines.Add("XVTR 80 minimum frequency," + frequency_80_minimum.ToString());
            lines.Add("XVTR 80 maximum frequency," + frequency_80_maximum.ToString());
            lines.Add("XVTR 40 minimum frequency," + frequency_40_minimum.ToString());
            lines.Add("XVTR 40 maximum frequency," + frequency_40_maximum.ToString());
            lines.Add("XVTR 30 minimum frequency," + frequency_30_minimum.ToString());
            lines.Add("XVTR 30 maximum frequency," + frequency_30_maximum.ToString());
            lines.Add("XVTR 20 minimum frequency," + frequency_20_minimum.ToString());
            lines.Add("XVTR 20 maximum frequency," + frequency_20_maximum.ToString());
            lines.Add("XVTR 17 minimum frequency," + frequency_17_minimum.ToString());
            lines.Add("XVTR 17 maximum frequency," + frequency_17_maximum.ToString());
            lines.Add("XVTR 15 minimum frequency," + frequency_15_minimum.ToString());
            lines.Add("XVTR 15 maximum frequency," + frequency_15_maximum.ToString());
            lines.Add("XVTR 12 minimum frequency," + frequency_12_minimum.ToString());
            lines.Add("XVTR 12 maximum frequency," + frequency_12_maximum.ToString());
            lines.Add("XVTR 10 minimum frequency," + frequency_10_minimum.ToString());
            lines.Add("XVTR 10 maximum frequency," + frequency_10_maximum.ToString());
            lines.Add("XVTR 6 minimum frequency," + frequency_6_minimum.ToString());
            lines.Add("XVTR 6 maximum frequency," + frequency_6_maximum.ToString());
            lines.Add("XVTR GC minimum frequency," + frequency_GC_minimum.ToString());
            lines.Add("XVTR GC maximum frequency," + frequency_GC_maximum.ToString());
 
            lines.Add("LFootMainBut," + LFootMainBut.Checked.ToString(nfi));
            lines.Add("LFootAuxBut," + LFootAuxBut.Checked.ToString(nfi));
            lines.Add("KeyMainBut," + KeyMainBut.Checked.ToString(nfi));
            lines.Add("KeyAuxBut," + KeyAuxBut.Checked.ToString(nfi));
            
            lines.Add("Globals CWPitch," + Globals.CWPitch);
            lines.Add("Sidetone Volume," + Globals.sidetonevol);


            // Serial ports for communication with W3SZ SDR Controller
            try
            {
       //         lines.Add("N1MM COM Port," + Properties.Settings.Default.N1MMCOM);
            }
            catch
            {
      //          lines.Add("N1MM COM Port," + "COM9");
            }
            try
            {
     //           lines.Add("N1MM COM Liaison Port," + Properties.Settings.Default.N1MMCOMLiaison);
            }
            catch
            {
    //            lines.Add("N1MM COM Liaison Port," + "COM9");
            }
            // write all the lines
            try
            {
                File.WriteAllLines(KKCSVName, lines.ToArray());
            }
            catch
            {
            }
        }

        public string LookupKKCSVValue(string key, string defaultValue, List<string> value)
        {
            for (int i = 0; i < value.Count; i += 2)
            {
                string s = value[i];
                // search all the even index entries for a key that matches.  If there is one, return
                // the next list entry
                if (s.Equals(key, StringComparison.InvariantCulture))
                {
                    // they match.  return the next element in value
                    return value[i + 1];
                }
            }

            // not found.  Return default value instead
            return defaultValue;
        }

        public double LookupKKCSVValue(string key, double defaultValue, List<string> value)
        {
            for (int i = 0; i < value.Count; i += 2)
            {
                string s = value[i];
                // search all the even index entries for a key that matches.  If there is one, return
                // the next list entry
                if (s.Equals(key, StringComparison.InvariantCulture))
                {
                    // they match.  return the next element in value
                    try
                    {
                        return (float)Convert.ToDouble(value[i + 1], nfi);
                    }
                    catch
                    {
                        return defaultValue;
                    }
                }
            }

            // not found.  Return default value instead
            return defaultValue;
        }

        public int LookupKKCSVValue(string key, int defaultValue, List<string> value)
        {
            for (int i = 0; i < value.Count; i += 2)
            {
                string s = value[i];
                // search all the even index entries for a key that matches.  If there is one, return
                // the next list entry
                if (s.Equals(key, StringComparison.InvariantCulture))
                {
                    // they match.  return the next element in value
                    try
                    {
                        return Convert.ToInt32(value[i + 1], nfi);
                    }
                    catch
                    {
                        return defaultValue;
                    }
                }
            }

            // not found.  Return default value instead
            return defaultValue;
        }


        public long LookupKKCSVValue(string key, long defaultValue, List<string> value)
        {
            for (int i = 0; i < value.Count; i += 2)
            {
                string s = value[i];
                // search all the even index entries for a key that matches.  If there is one, return
                // the next list entry
                if (s.Equals(key, StringComparison.InvariantCulture))
                {
                    // they match.  return the next element in value
                    try
                    {
                        return Convert.ToInt64(value[i + 1], nfi);
                    }
                    catch
                    {
                        return defaultValue;
                    }
                }
            }

            // not found.  Return default value instead
            return defaultValue;
        }

        public bool LookupKKCSVValue(string key, bool defaultValue, List<string> value)
        {
            for (int i = 0; i < value.Count; i += 2)
            {
                string s = value[i];
                // search all the even index entries for a key that matches.  If there is one, return
                // the next list entry
                if (s.Equals(key, StringComparison.InvariantCulture))
                {
                    // they match.  return the next element in value
                    try
                    {
                        return Convert.ToBoolean(value[i + 1], nfi);
                    }
                    catch
                    {
                        return defaultValue;
                    }
                }
            }

            // not found.  Return default value instead
            return defaultValue;
        }

        public void ReadKKCSV(string KKCSVName)
        {
            // read the file into an array so we can process each entry
      //      try
            {
                var lines = File.ReadAllLines(KKCSVName);
                List<string> value = new List<string>();

                // process the string array of data that was read
                foreach (string text in lines)
                {
                    /* This gets around the problem of the locale of the user as far as saving floating point
                     * values which might (because of locale) have commas in the numbers, thus creating
                     * more entries in the array than desired, because of mis-parsing based on the extra commas.
                     * We also get to use a List<string> so that we don't need to know how big it is before we process
                     * data.  It indexes the same as 'string[] value' did.
                     */
                    int p = text.IndexOf(",");      // search for the comma after the data element name
                    if (p != -1)
                    {
                        // we found a comma.  Split the line into 'before' and 'after' the comma
                        // before the comma is the data name
                        // after the comma is its value
                        value.Add(text.Substring(0, p));
                        value.Add(text.Substring(p + 1));
                    }
                }



                // Assign the values in Moving_Forms_Test to their respective variables for Micro
                //TODO: Save radio state on a per-band basis

                // get what type last run used (Ethernet or USB)
                int microkkDevice = LookupKKCSVValue("Micro KKDevice", (int)Micro.KKDevice, value);
                try
                {
                    Micro.KKDevice = (KKMethod)microkkDevice;
                }
                catch
                {
                    Micro.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
   //             if (Properties.Settings.Default.HFChecked)
                {
                    _HF.BandText = LookupKKCSVValue("HF Band", _HF.BandText, value);
                }
                Globals.microband = LookupKKCSVValue("Micro Band", Globals.microband, value);
                Micro.SampleRate = LookupKKCSVValue("Micro Sample Rate", Micro.SampleRate, value);
                MicroMHz.FFTSize = LookupKKCSVValue("Micro FFTSize", MicroMHz.FFTSize, value);
                Micro.stepSize.Text = LookupKKCSVValue("Micro Step Size", Micro.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                Micro.Mode.Text = LookupKKCSVValue("Micro Mode", Micro.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("Micro Volume", Micro.VolumeTrackBar.Value, value), Micro.VolumeTrackBar);

                Micro.AGCSpeed.Text = LookupKKCSVValue("Micro AGC Speed", Micro.AGCSpeed.Text, value);
                MicroMHz.AGCMaximumGainDB = LookupKKCSVValue("Micro AGC Max Gain", MicroMHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(MicroMHz.AGCMaximumGainDB), Micro.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("Micro Bandwidth", Micro.BandwidthTrackBar.Value, value), Micro.BandwidthTrackBar);
                Micro.ANF.Checked = LookupKKCSVValue("Micro ANF", Micro.ANF.Checked, value);
                Micro.NR.Checked = LookupKKCSVValue("Micro NR", Micro.NR.Checked, value);
                Micro.NB1.Checked = LookupKKCSVValue("Micro NB1", Micro.NB1.Checked, value);
                Micro.NB2.Checked = LookupKKCSVValue("Micro NB2", Micro.NB2.Checked, value);
                Micro.Rate = LookupKKCSVValue("Micro Rate", Micro.Rate, value);
 
                MicroMHz.GridMax = LookupKKCSVValue("Micro Bandscope Grid Max", MicroMHz.GridMax, value);
                MicroMHz.GridMin = LookupKKCSVValue("Micro Bandscope Grid Min", MicroMHz.GridMin, value);
                MicroMHz.GridStep = LookupKKCSVValue("Micro Bandscope Grid Step", MicroMHz.GridStep, value);
                Moving_Forms_Test.MicroMHz.color_scheme = LookupKKCSVValue("Micro Waterfall Palette", Moving_Forms_Test.MicroMHz.color_scheme, value);

                Micro.WaterfallHighThreshold = LookupKKCSVValue("Micro WaterfallHigh", Micro.WaterfallHighThreshold, value);
                Micro.WaterfallLowThreshold = LookupKKCSVValue("Micro WaterfallLow", Micro.WaterfallLowThreshold, value);
                MicroMHz.WaterfallAGC = LookupKKCSVValue("Micro WaterFall AGC", MicroMHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("Micro Squelch level", Micro.Squelch_level.Value, value), Micro.Squelch_level);

                Micro.Bandscope_squelch.Checked = LookupKKCSVValue("Micro Bandscope Squelch", Micro.Bandscope_squelch.Checked, value); 
                Micro.Filter_squelch.Checked = LookupKKCSVValue("Micro Filter Squelch", Micro.Filter_squelch.Checked, value);

                Micro.chkClipper.Checked = LookupKKCSVValue("Micro Speech Processor", Micro.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("Micro Processor Gain", Micro.ProcessorGain.Value, value), Micro.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("Micro Mic Gain", Micro.MicrophoneGain.Value, value), Micro.MicrophoneGain);
                Micro.chkNoiseGate.Checked = LookupKKCSVValue("Micro Noise Gate", Micro.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("Micro Noise Gate Level", Micro.NoiseGateLevel.Value, value), Micro.NoiseGateLevel);

                MicroMHz.w3szendpoint1 = LookupKKCSVValue("w3szendpointGHz", MicroMHz.w3szendpoint1, value);
                MicroMHz.Duplex = LookupKKCSVValue("Micro Full Duplex", MicroMHz.Duplex, value);
                MicroMHz.OnlyTxOnPTT = LookupKKCSVValue("Micro Only Tx on PTT", MicroMHz.OnlyTxOnPTT, value);
                MicroMHz.TuneLevel = LookupKKCSVValue("Micro Tune Level", MicroMHz.TuneLevel, value);
                MicroMHz.DelayRF = LookupKKCSVValue("Micro DelayRF", MicroMHz.DelayRF, value);
                MicroMHz.DelayPTT = LookupKKCSVValue("Micro DelayPTT", MicroMHz.DelayPTT, value);
                MicroMHz.FM_deviation = LookupKKCSVValue("Micro FM deviation", MicroMHz.FM_deviation, value);
                MicroMHz.TxFilterHigh = (float)LookupKKCSVValue("Micro Tx Filter High", MicroMHz.TxFilterHigh, value);
                MicroMHz.TxFilterLow = (float)LookupKKCSVValue("Micro Tx Filter Low", MicroMHz.TxFilterLow, value);
                Micro.Zoom100.Checked = LookupKKCSVValue("Micro Zoom100", Micro.Zoom100.Checked, value);
                Micro.Zoom75.Checked = LookupKKCSVValue("Micro Zoom75", Micro.Zoom75.Checked, value);
                Micro.Zoom50.Checked = LookupKKCSVValue("Micro Zoom50", Micro.Zoom50.Checked, value);
                Micro.Zoom25.Checked = LookupKKCSVValue("Micro Zoom25", Micro.Zoom25.Checked, value);
                Micro.Zoom_Track_Bar.Value = LookupKKCSVValue("Micro Track Bar", Micro.Zoom_Track_Bar.Value, value);

                SafeTrackBarValueChange(LookupKKCSVValue("Micro Drive Level", Micro.DriveLevel.Value, value), Micro.DriveLevel);

                MicroMHz.EnableBandData = LookupKKCSVValue("Enable Micro Band Data", MicroMHz.EnableBandData, value);
                MicroMHz.LPT_Addr = LookupKKCSVValue("LPT Address", MicroMHz.LPT_Addr, value);

                                
                // Assign the values in Moving_Forms_Test to their respective variables for _50

                // get what type last run used (Ethernet or USB)
                int _50kkDevice = LookupKKCSVValue("_50 KKDevice", (int)_50.KKDevice, value);
                try
                {
                    _50.KKDevice = (KKMethod)_50kkDevice;
                }
                catch
                {
                    _50.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _50.SampleRate = LookupKKCSVValue("_50 Sample Rate", _50.SampleRate, value);
                _50MHz.FFTSize = LookupKKCSVValue("_50 FFTSize", _50MHz.FFTSize, value);
                _50.stepSize.Text = LookupKKCSVValue("_50 Step Size", _50.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _50.Mode.Text = LookupKKCSVValue("_50 Mode", _50.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_50 Volume", _50.VolumeTrackBar.Value, value), _50.VolumeTrackBar);

                _50.AGCSpeed.Text = LookupKKCSVValue("_50 AGC Speed", _50.AGCSpeed.Text, value);
                _50MHz.AGCMaximumGainDB = LookupKKCSVValue("_50 AGC Max Gain", _50MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_50MHz.AGCMaximumGainDB), _50.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("_50 Bandwidth", _50.BandwidthTrackBar.Value, value), _50.BandwidthTrackBar);
                _50.ANF.Checked = LookupKKCSVValue("_50 ANF", _50.ANF.Checked, value);
                _50.NR.Checked = LookupKKCSVValue("_50 NR", _50.NR.Checked, value);
                _50.NB1.Checked = LookupKKCSVValue("_50 NB1", _50.NB1.Checked, value);
                _50.NB2.Checked = LookupKKCSVValue("_50 NB2", _50.NB2.Checked, value);
                _50.Rate = LookupKKCSVValue("_50 Rate", _50.Rate, value);
 
                _50MHz.GridMax = LookupKKCSVValue("_50 Bandscope Grid Max", _50MHz.GridMax, value);
                _50MHz.GridMin = LookupKKCSVValue("_50 Bandscope Grid Min", _50MHz.GridMin, value);
                _50MHz.GridStep = LookupKKCSVValue("_50 Bandscope Grid Step", _50MHz.GridStep, value);
                Moving_Forms_Test._50MHz.color_scheme = LookupKKCSVValue("_50 Waterfall Palette", Moving_Forms_Test._50MHz.color_scheme, value);

                _50.WaterfallHighThreshold = LookupKKCSVValue("_50 WaterfallHigh", _50.WaterfallHighThreshold, value);
                _50.WaterfallLowThreshold = LookupKKCSVValue("_50 WaterfallLow", _50.WaterfallLowThreshold, value);
                _50MHz.WaterfallAGC = LookupKKCSVValue("_50 WaterFall AGC", _50MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_50 Squelch level", _50.Squelch_level.Value, value), _50.Squelch_level);
                _50.Bandscope_squelch.Checked = LookupKKCSVValue("_50 Bandscope Squelch", _50.Bandscope_squelch.Checked, value);
                _50.Filter_squelch.Checked = LookupKKCSVValue("_50 Filter Squelch", _50.Filter_squelch.Checked, value);
                _50.chkClipper.Checked = LookupKKCSVValue("_50 Speech Processor", _50.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_50 Processor Gain", _50.ProcessorGain.Value, value), _50.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_50 Mic Gain", _50.MicrophoneGain.Value, value), _50.MicrophoneGain);
                _50.chkNoiseGate.Checked = LookupKKCSVValue("_50 Noise Gate", _50.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_50 Noise Gate Level", _50.NoiseGateLevel.Value, value), _50.NoiseGateLevel);

                _50MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint50", _50MHz.w3szendpoint1, value);
                _50MHz.Duplex = LookupKKCSVValue("_50 Full Duplex", _50MHz.Duplex, value);
                _50MHz.OnlyTxOnPTT = LookupKKCSVValue("_50 Only Tx on PTT", _50MHz.OnlyTxOnPTT, value);
                _50MHz.TuneLevel = LookupKKCSVValue("_50 Tune Level", _50MHz.TuneLevel, value);
                _50MHz.TxFilterHigh = (float)LookupKKCSVValue("_50 Tx Filter High", _50MHz.TxFilterHigh, value);
                _50MHz.TxFilterLow = (float)LookupKKCSVValue("_50 Tx Filter Low", _50MHz.TxFilterLow, value);
                _50.Zoom100.Checked = LookupKKCSVValue("_50 Zoom100", _50.Zoom100.Checked, value);
                _50.Zoom75.Checked = LookupKKCSVValue("_50 Zoom75", _50.Zoom75.Checked, value);
                _50.Zoom50.Checked = LookupKKCSVValue("_50 Zoom50", _50.Zoom50.Checked, value);
                _50.Zoom25.Checked = LookupKKCSVValue("_50 Zoom25", _50.Zoom25.Checked, value);
                _50.Zoom_Track_Bar.Value = LookupKKCSVValue("_50 Track Bar", _50.Zoom_Track_Bar.Value, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_50 Drive Level", _50.DriveLevel.Value, value), _50.DriveLevel);

                                
                                                                                
                // Assign the values in Moving_Forms_Test to their respective variables for _144

                // get what type last run used (Ethernet or USB)
                int _144kkDevice = LookupKKCSVValue("_144 KKDevice", (int)_144.KKDevice, value);
                try
                {
                    _144.KKDevice = (KKMethod)_144kkDevice;
                }
                catch
                {
                    _144.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _144.SampleRate = LookupKKCSVValue("_144 Sample Rate", _144.SampleRate, value);
                _144MHz.FFTSize = LookupKKCSVValue("_144 FFTSize", _144MHz.FFTSize, value);
                _144.stepSize.Text = LookupKKCSVValue("_144 Step Size", _144.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _144.Mode.Text = LookupKKCSVValue("_144 Mode", _144.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_144 Volume", _144.VolumeTrackBar.Value, value), _144.VolumeTrackBar);

                _144.AGCSpeed.Text = LookupKKCSVValue("_144 AGC Speed", _144.AGCSpeed.Text, value);
                _144MHz.AGCMaximumGainDB = LookupKKCSVValue("_144 AGC Max Gain", _144MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_144MHz.AGCMaximumGainDB), _144.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("_144 Bandwidth", _144.BandwidthTrackBar.Value, value), _144.BandwidthTrackBar);
                _144.ANF.Checked = LookupKKCSVValue("_144 ANF", _144.ANF.Checked, value);
                _144.NR.Checked = LookupKKCSVValue("_144 NR", _144.NR.Checked, value);
                _144.NB1.Checked = LookupKKCSVValue("_144 NB1", _144.NB1.Checked, value);
                _144.NB2.Checked = LookupKKCSVValue("_144 NB2", _144.NB2.Checked, value);
                _144.Rate = LookupKKCSVValue("_144 Rate", _144.Rate, value);
 
                _144MHz.GridMax = LookupKKCSVValue("_144 Bandscope Grid Max", _144MHz.GridMax, value);
                _144MHz.GridMin = LookupKKCSVValue("_144 Bandscope Grid Min", _144MHz.GridMin, value);
                _144MHz.GridStep = LookupKKCSVValue("_144 Bandscope Grid Step", _144MHz.GridStep, value);

                _144.WaterfallHighThreshold = LookupKKCSVValue("_144 WaterfallHigh", _144.WaterfallHighThreshold, value);
                _144.WaterfallLowThreshold = LookupKKCSVValue("_144 WaterfallLow", _144.WaterfallLowThreshold, value);
                _144MHz.WaterfallAGC = LookupKKCSVValue("_144 WaterFall AGC", _144MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_144 Squelch level", _144.Squelch_level.Value, value), _144.Squelch_level);
                _144.Bandscope_squelch.Checked = LookupKKCSVValue("_144 Bandscope Squelch", _144.Bandscope_squelch.Checked, value);
                _144.Filter_squelch.Checked = LookupKKCSVValue("_144 Filter Squelch", _144.Filter_squelch.Checked, value);
                
                _144.chkClipper.Checked = LookupKKCSVValue("_144 Speech Processor", _144.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_144 Processor Gain", _144.ProcessorGain.Value, value), _144.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_144 Mic Gain", _144.MicrophoneGain.Value, value), _144.MicrophoneGain);
                _144.chkNoiseGate.Checked = LookupKKCSVValue("_144 Noise Gate", _144.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_144 Noise Gate Level", _144.NoiseGateLevel.Value, value), _144.NoiseGateLevel);

                _144MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint144", _144MHz.w3szendpoint1, value);
                _144MHz.Duplex = LookupKKCSVValue("_144 Full Duplex", _144MHz.Duplex, value);
                _144MHz.OnlyTxOnPTT = LookupKKCSVValue("_144 Only Tx on PTT", _144MHz.OnlyTxOnPTT, value);
                _144MHz.TuneLevel = LookupKKCSVValue("_144 Tune Level", _144MHz.TuneLevel, value);
                _144MHz.TxFilterHigh = (float)LookupKKCSVValue("_144 Tx Filter High", _144MHz.TxFilterHigh, value);
                _144MHz.TxFilterLow = (float)LookupKKCSVValue("_144 Tx Filter Low", _144MHz.TxFilterLow, value);
                _144.Zoom100.Checked = LookupKKCSVValue("_144 Zoom100", _144.Zoom100.Checked, value);
                _144.Zoom75.Checked = LookupKKCSVValue("_144 Zoom75", _144.Zoom75.Checked, value);
                _144.Zoom50.Checked = LookupKKCSVValue("_144 Zoom50", _144.Zoom50.Checked, value);
                _144.Zoom25.Checked = LookupKKCSVValue("_144 Zoom25", _144.Zoom25.Checked, value);
                _144.Zoom_Track_Bar.Value = LookupKKCSVValue("_144 Track Bar", _144.Zoom_Track_Bar.Value, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_144 Drive Level", _144.DriveLevel.Value, value), _144.DriveLevel);

                                                                
                                                                
                // Assign the values in Moving_Forms_Test to their respective variables for _222  

                // get what type last run used (Ethernet or USB)
                int _222kkDevice = LookupKKCSVValue("_222 KKDevice", (int)_222.KKDevice, value);
                try
                {
                    _222.KKDevice = (KKMethod)_222kkDevice;
                }
                catch
                {
                    _222.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _222.SampleRate = LookupKKCSVValue("_222 Sample Rate", _222.SampleRate, value);
                _222MHz.FFTSize = LookupKKCSVValue("_222 FFTSize", _222MHz.FFTSize, value);
                _222.stepSize.Text = LookupKKCSVValue("_222 Step Size", _222.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _222.Mode.Text = LookupKKCSVValue("_222 Mode", _222.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_222 Volume", _222.VolumeTrackBar.Value, value), _222.VolumeTrackBar);

                _222.AGCSpeed.Text = LookupKKCSVValue("_222 AGC Speed", _222.AGCSpeed.Text, value);
                _222MHz.AGCMaximumGainDB = LookupKKCSVValue("_222 AGC Max Gain", _222MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_222MHz.AGCMaximumGainDB), _222.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("_222 Bandwidth", _222.BandwidthTrackBar.Value, value), _222.BandwidthTrackBar);
                _222.ANF.Checked = LookupKKCSVValue("_222 ANF", _222.ANF.Checked, value);
                _222.NR.Checked = LookupKKCSVValue("_222 NR", _222.NR.Checked, value);
                _222.NB1.Checked = LookupKKCSVValue("_222 NB1", _222.NB1.Checked, value);
                _222.NB2.Checked = LookupKKCSVValue("_222 NB2", _222.NB2.Checked, value);
                _222.Rate = LookupKKCSVValue("_222 Rate", _222.Rate, value);
 
                _222MHz.GridMax = LookupKKCSVValue("_222 Bandscope Grid Max", _222MHz.GridMax, value);
                _222MHz.GridMin = LookupKKCSVValue("_222 Bandscope Grid Min", _222MHz.GridMin, value);
                _222MHz.GridStep = LookupKKCSVValue("_222 Bandscope Grid Step", _222MHz.GridStep, value);
                Moving_Forms_Test._222MHz.color_scheme = LookupKKCSVValue("_222 Waterfall Palette", Moving_Forms_Test._222MHz.color_scheme, value);

                _222.WaterfallHighThreshold = LookupKKCSVValue("_222 WaterfallHigh", _222.WaterfallHighThreshold, value);
                _222.WaterfallLowThreshold = LookupKKCSVValue("_222 WaterfallLow", _222.WaterfallLowThreshold, value);
                _222MHz.WaterfallAGC = LookupKKCSVValue("_222 WaterFall AGC", _222MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_222 Squelch level", _222.Squelch_level.Value, value), _222.Squelch_level);
                _222.Bandscope_squelch.Checked = LookupKKCSVValue("_222 Bandscope Squelch", _222.Bandscope_squelch.Checked, value);
                _222.Filter_squelch.Checked = LookupKKCSVValue("_222 Filter Squelch", _222.Filter_squelch.Checked, value);

                _222.chkClipper.Checked = LookupKKCSVValue("_222 Speech Processor", _222.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_222 Processor Gain", _222.ProcessorGain.Value, value), _222.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_222 Mic Gain", _222.MicrophoneGain.Value, value), _222.MicrophoneGain);
                _222.chkNoiseGate.Checked = LookupKKCSVValue("_222 Noise Gate", _222.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_222 Noise Gate Level", _222.NoiseGateLevel.Value, value), _222.NoiseGateLevel);

                _222MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint222", _222MHz.w3szendpoint1, value);
                _222MHz.Duplex = LookupKKCSVValue("_222 Full Duplex", _222MHz.Duplex, value);
                _222MHz.OnlyTxOnPTT = LookupKKCSVValue("_222 Only Tx on PTT", _222MHz.OnlyTxOnPTT, value);
                _222MHz.TuneLevel = LookupKKCSVValue("_222 Tune Level", _222MHz.TuneLevel, value);
                _222MHz.TxFilterHigh = (float)LookupKKCSVValue("_222 Tx Filter High", _222MHz.TxFilterHigh, value);
                _222MHz.TxFilterLow = (float)LookupKKCSVValue("_222 Tx Filter Low", _222MHz.TxFilterLow, value);
                _222.Zoom100.Checked = LookupKKCSVValue("_222 Zoom100", _222.Zoom100.Checked, value);
                _222.Zoom75.Checked = LookupKKCSVValue("_222 Zoom75", _222.Zoom75.Checked, value);
                _222.Zoom50.Checked = LookupKKCSVValue("_222 Zoom50", _222.Zoom50.Checked, value);
                _222.Zoom25.Checked = LookupKKCSVValue("_222 Zoom25", _222.Zoom25.Checked, value);
                _222.Zoom_Track_Bar.Value = LookupKKCSVValue("_222 Track Bar", _222.Zoom_Track_Bar.Value, value);



                SafeTrackBarValueChange(LookupKKCSVValue("_222 Drive Level", _222.DriveLevel.Value, value), _222.DriveLevel);
                                      
                
                              
                // Assign the values in Moving_Forms_Test to their respective variables for _432

                // get what type last run used (Ethernet or USB)
                int _432kkDevice = LookupKKCSVValue("_432 KKDevice", (int)_432.KKDevice, value);
                try
                {
                    _432.KKDevice = (KKMethod)_432kkDevice;
                }
                catch
                {
                    _432.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _432.SampleRate = LookupKKCSVValue("_432 Sample Rate", _432.SampleRate, value);
                _432MHz.FFTSize = LookupKKCSVValue("_432 FFTSize", _432MHz.FFTSize, value);
                _432.stepSize.Text = LookupKKCSVValue("_432 Step Size", _432.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _432.Mode.Text = LookupKKCSVValue("_432 Mode", _432.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_432 Volume", _432.VolumeTrackBar.Value, value), _432.VolumeTrackBar);

                _432.AGCSpeed.Text = LookupKKCSVValue("_432 AGC Speed", _432.AGCSpeed.Text, value);
                _432MHz.AGCMaximumGainDB = LookupKKCSVValue("_432 AGC Max Gain", _432MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_432MHz.AGCMaximumGainDB), _432.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("_432 Bandwidth", _432.BandwidthTrackBar.Value, value), _432.BandwidthTrackBar);
                _432.ANF.Checked = LookupKKCSVValue("_432 ANF", _432.ANF.Checked, value);
                _432.NR.Checked = LookupKKCSVValue("_432 NR", _432.NR.Checked, value);
                _432.NB1.Checked = LookupKKCSVValue("_432 NB1", _432.NB1.Checked, value);
                _432.NB2.Checked = LookupKKCSVValue("_432 NB2", _432.NB2.Checked, value);
                _432.Rate = LookupKKCSVValue("_432 Rate", _432.Rate, value);
 
                _432MHz.GridMax = LookupKKCSVValue("_432 Bandscope Grid Max", _432MHz.GridMax, value);
                _432MHz.GridMin = LookupKKCSVValue("_432 Bandscope Grid Min", _432MHz.GridMin, value);
                _432MHz.GridStep = LookupKKCSVValue("_432 Bandscope Grid Step", _432MHz.GridStep, value);
                Moving_Forms_Test._432MHz.color_scheme = LookupKKCSVValue("_432 Waterfall Palette", Moving_Forms_Test._432MHz.color_scheme, value);

                _432.WaterfallHighThreshold = LookupKKCSVValue("_432 WaterfallHigh", _432.WaterfallHighThreshold, value);
                _432.WaterfallLowThreshold = LookupKKCSVValue("_432 WaterfallLow", _432.WaterfallLowThreshold, value);
                _432MHz.WaterfallAGC = LookupKKCSVValue("_432 WaterFall AGC", _432MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_432 Squelch level", _432.Squelch_level.Value, value), _432.Squelch_level);
                _432.Bandscope_squelch.Checked = LookupKKCSVValue("_432 Bandscope Squelch", _432.Bandscope_squelch.Checked, value);
                _432.Filter_squelch.Checked = LookupKKCSVValue("_432 Filter Squelch", _432.Filter_squelch.Checked, value);

                _432.chkClipper.Checked = LookupKKCSVValue("_432 Speech Processor", _432.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_432 Processor Gain", _432.ProcessorGain.Value, value), _432.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_432 Mic Gain", _432.MicrophoneGain.Value, value), _432.MicrophoneGain);
                _432.chkNoiseGate.Checked = LookupKKCSVValue("_432 Noise Gate", _432.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_432 Noise Gate Level", _432.NoiseGateLevel.Value, value), _432.NoiseGateLevel);

                _432MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint432", _432MHz.w3szendpoint1, value);
                _432MHz.Duplex = LookupKKCSVValue("_432 Full Duplex", _432MHz.Duplex, value);
                _432MHz.OnlyTxOnPTT = LookupKKCSVValue("_432 Only Tx on PTT", _432MHz.OnlyTxOnPTT, value);
                _432MHz.TuneLevel = LookupKKCSVValue("_432 Tune Level", _432MHz.TuneLevel, value);
                _432MHz.TxFilterHigh = (float)LookupKKCSVValue("_432 Tx Filter High", _432MHz.TxFilterHigh, value);
                _432MHz.TxFilterLow = (float)LookupKKCSVValue("_432 Tx Filter Low", _432MHz.TxFilterLow, value);
                _432.Zoom100.Checked = LookupKKCSVValue("_432 Zoom100", _432.Zoom100.Checked, value);
                _432.Zoom75.Checked = LookupKKCSVValue("_432 Zoom75", _432.Zoom75.Checked, value);
                _432.Zoom50.Checked = LookupKKCSVValue("_432 Zoom50", _432.Zoom50.Checked, value);
                _432.Zoom25.Checked = LookupKKCSVValue("_432 Zoom25", _432.Zoom25.Checked, value);
                _432.Zoom_Track_Bar.Value = LookupKKCSVValue("_432 Track Bar", _432.Zoom_Track_Bar.Value, value);


                SafeTrackBarValueChange(LookupKKCSVValue("_432 Drive Level", _432.DriveLevel.Value, value), _432.DriveLevel);

                
                
                // Assign the values in Moving_Forms_Test to their respective variables for _903

                // get what type last run used (Ethernet or USB)
                int _903kkDevice = LookupKKCSVValue("_903 KKDevice", (int)_903.KKDevice, value);
                try
                {
                    _903.KKDevice = (KKMethod)_903kkDevice;
                }
                catch
                {
                    _903.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _903.SampleRate = LookupKKCSVValue("_903 Sample Rate", _903.SampleRate, value);
                _903MHz.FFTSize = LookupKKCSVValue("_903 FFTSize", _903MHz.FFTSize, value);
                _903.stepSize.Text = LookupKKCSVValue("_903 Step Size", _903.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _903.Mode.Text = LookupKKCSVValue("_903 Mode", _903.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_903 Volume", _903.VolumeTrackBar.Value, value), _903.VolumeTrackBar);

                _903.AGCSpeed.Text = LookupKKCSVValue("_903 AGC Speed", _903.AGCSpeed.Text, value);
                _903MHz.AGCMaximumGainDB = LookupKKCSVValue("_903 AGC Max Gain", _903MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_903MHz.AGCMaximumGainDB), _903.AGCTrackBar);
 
                SafeTrackBarValueChange(LookupKKCSVValue("_903 Bandwidth", _903.BandwidthTrackBar.Value, value), _903.BandwidthTrackBar);
                _903.ANF.Checked = LookupKKCSVValue("_903 ANF", _903.ANF.Checked, value);
                _903.NR.Checked = LookupKKCSVValue("_903 NR", _903.NR.Checked, value);
                _903.NB1.Checked = LookupKKCSVValue("_903 NB1", _903.NB1.Checked, value);
                _903.NB2.Checked = LookupKKCSVValue("_903 NB2", _903.NB2.Checked, value);
                _903.Rate = LookupKKCSVValue("_903 Rate", _903.Rate, value);
 
                _903MHz.GridMax = LookupKKCSVValue("_903 Bandscope Grid Max", _903MHz.GridMax, value);
                _903MHz.GridMin = LookupKKCSVValue("_903 Bandscope Grid Min", _903MHz.GridMin, value);
                _903MHz.GridStep = LookupKKCSVValue("_903 Bandscope Grid Step", _903MHz.GridStep, value);
                Moving_Forms_Test._903MHz.color_scheme = LookupKKCSVValue("_903 Waterfall Palette", Moving_Forms_Test._903MHz.color_scheme, value);

                _903.WaterfallHighThreshold = LookupKKCSVValue("_903 WaterfallHigh", _903.WaterfallHighThreshold, value);
                _903.WaterfallLowThreshold = LookupKKCSVValue("_903 WaterfallLow", _903.WaterfallLowThreshold, value);
                _903MHz.WaterfallAGC = LookupKKCSVValue("_903 WaterFall AGC", _903MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_903 Squelch level", _903.Squelch_level.Value, value), _903.Squelch_level);
                _903.Bandscope_squelch.Checked = LookupKKCSVValue("_903 Bandscope Squelch", _903.Bandscope_squelch.Checked, value);
                _903.Filter_squelch.Checked = LookupKKCSVValue("_903 Filter Squelch", _903.Filter_squelch.Checked, value);
                
                _903.chkClipper.Checked = LookupKKCSVValue("_903 Speech Processor", _903.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_903 Processor Gain", _903.ProcessorGain.Value, value), _903.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_903 Mic Gain", _903.MicrophoneGain.Value, value), _903.MicrophoneGain);
                _903.chkNoiseGate.Checked = LookupKKCSVValue("_903 Noise Gate", _903.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_903 Noise Gate Level", _903.NoiseGateLevel.Value, value), _903.NoiseGateLevel);

                _903MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint903", _903MHz.w3szendpoint1, value);
                _903MHz.Duplex = LookupKKCSVValue("_903 Full Duplex", _903MHz.Duplex, value);
                _903MHz.OnlyTxOnPTT = LookupKKCSVValue("_903 Only Tx on PTT", _903MHz.OnlyTxOnPTT, value);
                _903MHz.TuneLevel = LookupKKCSVValue("_903 Tune Level", _903MHz.TuneLevel, value);
                _903MHz.TxFilterHigh = (float)LookupKKCSVValue("_903 Tx Filter High", _903MHz.TxFilterHigh, value);
                _903MHz.TxFilterLow = (float)LookupKKCSVValue("_903 Tx Filter Low", _903MHz.TxFilterLow, value);
                _903.Zoom100.Checked = LookupKKCSVValue("_903 Zoom100", _903.Zoom100.Checked, value);
                _903.Zoom75.Checked = LookupKKCSVValue("_903 Zoom75", _903.Zoom75.Checked, value);
                _903.Zoom50.Checked = LookupKKCSVValue("_903 Zoom50", _903.Zoom50.Checked, value);
                _903.Zoom25.Checked = LookupKKCSVValue("_903 Zoom25", _903.Zoom25.Checked, value);
                _903.Zoom_Track_Bar.Value = LookupKKCSVValue("_903 Track Bar", _903.Zoom_Track_Bar.Value, value);


                SafeTrackBarValueChange(LookupKKCSVValue("_903 Drive Level", _903.DriveLevel.Value, value), _903.DriveLevel);

                
                
                // Assign the values in Moving_Forms_Test to their respective variables for _1296   

                // get what type last run used (Ethernet or USB)
                int _1296kkDevice = LookupKKCSVValue("_1296 KKDevice", (int)_1296.KKDevice, value);
                try
                {
                    _1296.KKDevice = (KKMethod)_1296kkDevice;
                }
                catch
                {
                    _1296.KKDevice = KKMethod.Ethernet;
                }

                // is it by design, or an error, that BandSelect.Text isn't set to this value?
                _1296.SampleRate = LookupKKCSVValue("_1296 Sample Rate", _1296.SampleRate, value);
                _1296MHz.FFTSize = LookupKKCSVValue("_1296 FFTSize", _1296MHz.FFTSize, value);
                _1296.stepSize.Text = LookupKKCSVValue("_1296 Step Size", _1296.stepSize.Text, value);

                // this next line forces ChangeMode to be called, which sets ModeText
                _1296.Mode.Text = LookupKKCSVValue("_1296 Mode", _1296.Mode.Text, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Volume", _1296.VolumeTrackBar.Value, value), _1296.VolumeTrackBar);

                _1296.AGCSpeed.Text = LookupKKCSVValue("_1296 AGC Speed", _1296.AGCSpeed.Text, value);
                _1296MHz.AGCMaximumGainDB = LookupKKCSVValue("_1296 AGC Max Gain", _1296MHz.AGCMaximumGainDB, value);
                SafeTrackBarValueChange(Convert.ToInt32(_1296MHz.AGCMaximumGainDB), _1296.AGCTrackBar);
                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Bandwidth", _1296.BandwidthTrackBar.Value, value), _1296.BandwidthTrackBar);
                _1296.ANF.Checked = LookupKKCSVValue("_1296 ANF", _1296.ANF.Checked, value);
                _1296.NR.Checked = LookupKKCSVValue("_1296 NR", _1296.NR.Checked, value);
                _1296.NB1.Checked = LookupKKCSVValue("_1296 NB1", _1296.NB1.Checked, value);
                _1296.NB2.Checked = LookupKKCSVValue("_1296 NB2", _1296.NB2.Checked, value);
                _1296.Rate = LookupKKCSVValue("_1296 Rate", _1296.Rate, value);
 
                _1296MHz.GridMax = LookupKKCSVValue("_1296 Bandscope Grid Max", _1296MHz.GridMax, value);
                _1296MHz.GridMin = LookupKKCSVValue("_1296 Bandscope Grid Min", _1296MHz.GridMin, value);
                _1296MHz.GridStep = LookupKKCSVValue("_1296 Bandscope Grid Step", _1296MHz.GridStep, value);
                Moving_Forms_Test._1296MHz.color_scheme = LookupKKCSVValue("_1296 Waterfall Palette", Moving_Forms_Test._1296MHz.color_scheme, value);

                _1296.WaterfallHighThreshold = LookupKKCSVValue("_1296 WaterfallHigh", _1296.WaterfallHighThreshold, value);
                _1296.WaterfallLowThreshold = LookupKKCSVValue("_1296 WaterfallLow", _1296.WaterfallLowThreshold, value);
                _1296MHz.WaterfallAGC = LookupKKCSVValue("_1296 WaterFall AGC", _1296MHz.WaterfallAGC, value);

                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Squelch level", _1296.Squelch_level.Value, value), _1296.Squelch_level);
                _1296.Bandscope_squelch.Checked = LookupKKCSVValue("_1296 Bandscope Squelch", _1296.Bandscope_squelch.Checked, value);
                _1296.Filter_squelch.Checked = LookupKKCSVValue("_1296 Filter Squelch", _1296.Filter_squelch.Checked, value);

                _1296.chkClipper.Checked = LookupKKCSVValue("_1296 Speech Processor", _1296.chkClipper.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Processor Gain", _1296.ProcessorGain.Value, value), _1296.ProcessorGain);
                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Mic Gain", _1296.MicrophoneGain.Value, value), _1296.MicrophoneGain);
                _1296.chkNoiseGate.Checked = LookupKKCSVValue("_1296 Noise Gate", _1296.chkNoiseGate.Checked, value);
                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Noise Gate Level", _1296.NoiseGateLevel.Value, value), _1296.NoiseGateLevel);

                _1296MHz.w3szendpoint1 = LookupKKCSVValue("w3szendpoint1296", _1296MHz.w3szendpoint1, value);
                _1296MHz.Duplex = LookupKKCSVValue("_1296 Full Duplex", _1296MHz.Duplex, value);
                _1296MHz.OnlyTxOnPTT = LookupKKCSVValue("_1296 Only Tx on PTT", _1296MHz.OnlyTxOnPTT, value);
                _1296MHz.TuneLevel = LookupKKCSVValue("_1296 Tune Level", _1296MHz.TuneLevel, value);
                _1296MHz.TxFilterHigh = (float)LookupKKCSVValue("_1296 Tx Filter High", _1296MHz.TxFilterHigh, value);
                _1296MHz.TxFilterLow = (float)LookupKKCSVValue("_1296 Tx Filter Low", _1296MHz.TxFilterLow, value);
                _1296.Zoom100.Checked = LookupKKCSVValue("_1296 Zoom100", _1296.Zoom100.Checked, value);
                _1296.Zoom75.Checked = LookupKKCSVValue("_1296 Zoom75", _1296.Zoom75.Checked, value);
                _1296.Zoom50.Checked = LookupKKCSVValue("_1296 Zoom50", _1296.Zoom50.Checked, value);
                _1296.Zoom25.Checked = LookupKKCSVValue("_1296 Zoom25", _1296.Zoom25.Checked, value);
                _1296.Zoom_Track_Bar.Value = LookupKKCSVValue("_1296 Track Bar", _1296.Zoom_Track_Bar.Value, value);


                SafeTrackBarValueChange(LookupKKCSVValue("_1296 Drive Level", _1296.DriveLevel.Value, value), _1296.DriveLevel);

   //             if (Properties.Settings.Default.HFChecked)
                {
                    // Assign the values in Moving_Forms_Test to their respective variables for _HF

                    // get what type last run used (Ethernet or USB)
                    int _HFkkDevice = LookupKKCSVValue("_HF KKDevice", (int)_HF.KKDevice, value);
                    try
                    {
                        _HF.KKDevice = (KKMethod)_HFkkDevice;
                    }
                    catch
                    {
                        _HF.KKDevice = KKMethod.Ethernet;
                    }

                    // is it by design, or an error, that BandSelect.Text isn't set to this value?
                    _HF.SampleRate = LookupKKCSVValue("_HF Sample Rate", _HF.SampleRate, value);
                    _HF.FFTSize = LookupKKCSVValue("_HF FFTSize", _HF.FFTSize, value);
                    _HF.stepSize.Text = LookupKKCSVValue("_HF Step Size", _HF.stepSize.Text, value);

                    // this next line forces ChangeMode to be called, which sets ModeText
                    _HF.Mode.Text = LookupKKCSVValue("_HF Mode", _HF.Mode.Text, value);
                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Volume", _HF.VolumeTrackBar.Value, value), _HF.VolumeTrackBar);

                    _HF.AGCSpeed.Text = LookupKKCSVValue("_HF AGC Speed", _HF.AGCSpeed.Text, value);
                    _HF.AGCMaximumGainDB = LookupKKCSVValue("_HF AGC Max Gain", _HF.AGCMaximumGainDB, value);
                    SafeTrackBarValueChange(Convert.ToInt32(_HF.AGCMaximumGainDB), _HF.AGCTrackBar);

                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Bandwidth", _HF.BandwidthTrackBar.Value, value), _HF.BandwidthTrackBar);
                    _HF.ANF.Checked = LookupKKCSVValue("_HF ANF", _HF.ANF.Checked, value);
                    _HF.NR.Checked = LookupKKCSVValue("_HF NR", _HF.NR.Checked, value);
                    _HF.NB1.Checked = LookupKKCSVValue("_HF NB1", _HF.NB1.Checked, value);
                    _HF.NB2.Checked = LookupKKCSVValue("_HF NB2", _HF.NB2.Checked, value);
                    _HF.Rate = LookupKKCSVValue("_HF Rate", _HF.Rate, value);

                    _HF.GridMax = LookupKKCSVValue("_HF Bandscope Grid Max", _HF.GridMax, value);
                    _HF.GridMin = LookupKKCSVValue("_HF Bandscope Grid Min", _HF.GridMin, value);
                    _HF.GridStep = LookupKKCSVValue("_HF Bandscope Grid Step", _HF.GridStep, value);
                    Moving_Forms_Test._HF.color_scheme = LookupKKCSVValue("_HF Waterfall Palette", Moving_Forms_Test._HF.color_scheme, value);

                    _HF.WaterfallHighThreshold = LookupKKCSVValue("_HF WaterfallHigh", _HF.WaterfallHighThreshold, value);
                    _HF.WaterfallLowThreshold = LookupKKCSVValue("_HF WaterfallLow", _HF.WaterfallLowThreshold, value);
                    _HF.WaterfallAGC = LookupKKCSVValue("_HF WaterFall AGC", _HF.WaterfallAGC, value);

                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Squelch level", _HF.Squelch_level.Value, value), _HF.Squelch_level);
                    _HF.Bandscope_squelch.Checked = LookupKKCSVValue("_HF Bandscope Squelch", _HF.Bandscope_squelch.Checked, value);
                    _HF.Filter_squelch.Checked = LookupKKCSVValue("_HF Filter Squelch", _HF.Filter_squelch.Checked, value);

                    _HF.chkClipper.Checked = LookupKKCSVValue("_HF Speech Processor", _HF.chkClipper.Checked, value);
                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Processor Gain", _HF.ProcessorGain.Value, value), _HF.ProcessorGain);
                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Mic Gain", _HF.MicrophoneGain.Value, value), _HF.MicrophoneGain);
                    _HF.chkNoiseGate.Checked = LookupKKCSVValue("_HF Noise Gate", _HF.chkNoiseGate.Checked, value);
                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Noise Gate Level", _HF.NoiseGateLevel.Value, value), _HF.NoiseGateLevel);

                    _HF.w3szendpoint1 = LookupKKCSVValue("w3szendpointHF", _HF.w3szendpoint1, value);
                    _HF.Duplex = LookupKKCSVValue("_HF Full Duplex", _HF.Duplex, value);
                    _HF.OnlyTxOnPTT = LookupKKCSVValue("_HF Only Tx on PTT", _HF.OnlyTxOnPTT, value);
                    _HF.TuneLevel = LookupKKCSVValue("_HF Tune Level", _HF.TuneLevel, value);
                    _HF.TxFilterHigh = (float)LookupKKCSVValue("_HF Tx Filter High", _HF.TxFilterHigh, value);
                    _HF.TxFilterLow = (float)LookupKKCSVValue("_HF Tx Filter Low", _HF.TxFilterLow, value);
                    _HF.Zoom100.Checked = LookupKKCSVValue("_HF Zoom100", _HF.Zoom100.Checked, value);
                    _HF.Zoom75.Checked = LookupKKCSVValue("_HF Zoom75", _HF.Zoom75.Checked, value);
                    _HF.Zoom50.Checked = LookupKKCSVValue("_HF Zoom50", _HF.Zoom50.Checked, value);
                    _HF.Zoom25.Checked = LookupKKCSVValue("_HF Zoom25", _HF.Zoom25.Checked, value);
                    _HF.Zoom_Track_Bar.Value = LookupKKCSVValue("_HF Track Bar", _HF.Zoom_Track_Bar.Value, value);


                    SafeTrackBarValueChange(LookupKKCSVValue("_HF Drive Level", _HF.DriveLevel.Value, value), _HF.DriveLevel);
                }
                                               
                              
                              
   //GLOBAL VARIABLES BELOW THAT DO NOT NEED TO BE STORED FOR EACH 
   //BAND WINDOW         

                Globals.xWidth = LookupKKCSVValue("xWidth", Globals.xWidth, value);
                Globals.color_scheme = LookupKKCSVValue("Waterfall Palette", Globals.color_scheme, value);

                // use last set frequency when starting
                Micro.xvtr_frequency_50 = LookupKKCSVValue("Last Freq 50MHz", Micro.xvtr_frequency_50, value);
                Micro.xvtr_frequency_144 = LookupKKCSVValue("Last Freq 144MHz", Micro.xvtr_frequency_144, value);
                Micro.xvtr_frequency_222 = LookupKKCSVValue("Last Freq 222MHz", Micro.xvtr_frequency_222, value);
                Micro.xvtr_frequency_432 = LookupKKCSVValue("Last Freq 432MHz", Micro.xvtr_frequency_432, value);
                Micro.xvtr_frequency_903 = LookupKKCSVValue("Last Freq 903MHz", Micro.xvtr_frequency_903, value);
                Micro.xvtr_frequency_1296 = LookupKKCSVValue("Last Freq 1296MHz", Micro.xvtr_frequency_1296, value);
                Micro.xvtr_frequency_2304 = LookupKKCSVValue("Last Freq 2304MHz", Micro.xvtr_frequency_2304, value);
                Micro.xvtr_frequency_3456 = LookupKKCSVValue("Last Freq 3456MHz", Micro.xvtr_frequency_3456, value);
                Micro.xvtr_frequency_5760 = LookupKKCSVValue("Last Freq 5760MHz", Micro.xvtr_frequency_5760, value);
                Micro.xvtr_frequency_10368 = LookupKKCSVValue("Last Freq 10368MHz", Micro.xvtr_frequency_10368, value);
                Micro.xvtr_frequency_24192 = LookupKKCSVValue("Last Freq 24192MHz", Micro.xvtr_frequency_24192, value);
   //             if (Properties.Settings.Default.HFChecked)
                {
                    _HF.set_frequency_160 = LookupKKCSVValue("Last Freq 160", _HF.set_frequency_160, value);
                    _HF.set_frequency_80 = LookupKKCSVValue("Last Freq 80", _HF.set_frequency_80, value);
                    _HF.set_frequency_40 = LookupKKCSVValue("Last Freq 40", _HF.set_frequency_40, value);
                    _HF.set_frequency_30 = LookupKKCSVValue("Last Freq 30", _HF.set_frequency_30, value);
                    _HF.set_frequency_20 = LookupKKCSVValue("Last Freq 20", _HF.set_frequency_20, value);
                    _HF.set_frequency_17 = LookupKKCSVValue("Last Freq 17", _HF.set_frequency_17, value);
                    _HF.set_frequency_15 = LookupKKCSVValue("Last Freq 15", _HF.set_frequency_15, value);
                    _HF.set_frequency_12 = LookupKKCSVValue("Last Freq 12", _HF.set_frequency_12, value);
                    _HF.set_frequency_10 = LookupKKCSVValue("Last Freq 10", _HF.set_frequency_10, value);
                    _HF.set_frequency_6 = LookupKKCSVValue("Last Freq 6", _HF.set_frequency_6, value);
                    _HF.set_frequency_GC = LookupKKCSVValue("Last Freq GC", _HF.set_frequency_GC, value);
                    try
                    {
                        _HF.set_frequency.Value = LookupKKCSVValue("_HF Last Freq", _HF.set_frequency.Value, value);
                    }
                    catch
                    {

                    }
       //             Globals.microband = LookupKKCSVValue("Micro Band", Globals.microband, value);  //duplicate entry
       //             _HF.BandText = LookupKKCSVValue("HF Band", _HF.BandText, value);
                }

                // save the preamp setting for each band
                MicroMHz.Preamp_50 = LookupKKCSVValue("Preamp 50", MicroMHz.Preamp_50, value);
                MicroMHz.Preamp_144 = LookupKKCSVValue("Preamp 144", MicroMHz.Preamp_144, value);
                MicroMHz.Preamp_222 = LookupKKCSVValue("Preamp 222", MicroMHz.Preamp_222, value);
                MicroMHz.Preamp_432 = LookupKKCSVValue("Preamp 432", MicroMHz.Preamp_432, value);
                MicroMHz.Preamp_903 = LookupKKCSVValue("Preamp 903", MicroMHz.Preamp_903, value);
                MicroMHz.Preamp_1296 = LookupKKCSVValue("Preamp 1296", MicroMHz.Preamp_1296, value);
                MicroMHz.Preamp_2304 = LookupKKCSVValue("Preamp 2304", MicroMHz.Preamp_2304, value);
                MicroMHz.Preamp_3456 = LookupKKCSVValue("Preamp 3456", MicroMHz.Preamp_3456, value);
                MicroMHz.Preamp_5760 = LookupKKCSVValue("Preamp 5760", MicroMHz.Preamp_5760, value);
                MicroMHz.Preamp_10368 = LookupKKCSVValue("Preamp 10368", MicroMHz.Preamp_10368, value);
                MicroMHz.Preamp_24192 = LookupKKCSVValue("Preamp 24192", MicroMHz.Preamp_24192, value);

   //             if (Properties.Settings.Default.HFChecked)
                {
                    _HF.Preamp_160 = LookupKKCSVValue("Preamp 160", _HF.Preamp_160, value);
                    _HF.Preamp_80 = LookupKKCSVValue("Preamp 80", _HF.Preamp_80, value);
                    _HF.Preamp_40 = LookupKKCSVValue("Preamp 40", _HF.Preamp_40, value);
                    _HF.Preamp_30 = LookupKKCSVValue("Preamp 30", _HF.Preamp_30, value);
                    _HF.Preamp_20 = LookupKKCSVValue("Preamp 20", _HF.Preamp_20, value);
                    _HF.Preamp_17 = LookupKKCSVValue("Preamp 17", _HF.Preamp_17, value);
                    _HF.Preamp_15 = LookupKKCSVValue("Preamp 15", _HF.Preamp_15, value);
                    _HF.Preamp_12 = LookupKKCSVValue("Preamp 12", _HF.Preamp_12, value);
                    _HF.Preamp_10 = LookupKKCSVValue("Preamp 10", _HF.Preamp_10, value);
                    _HF.Preamp_6 = LookupKKCSVValue("Preamp 6", _HF.Preamp_6, value);
                    _HF.Preamp_GC = LookupKKCSVValue("Preamp GC", _HF.Preamp_GC, value);
                    _HF.Drive = LookupKKCSVValue("Drive HF", _HF.Drive, value);
                    _HF.Gain160m = LookupKKCSVValue("Gain 160", _HF.Gain160m, value);
                    _HF.Gain80m = LookupKKCSVValue("Gain 80", _HF.Gain80m, value);
                    _HF.Gain40m = LookupKKCSVValue("Gain 40", _HF.Gain40m, value);
                    _HF.Gain30m = LookupKKCSVValue("Gain 30", _HF.Gain30m, value);
                    _HF.Gain20m = LookupKKCSVValue("Gain 20", _HF.Gain20m, value);
                    _HF.Gain17m = LookupKKCSVValue("Gain 17", _HF.Gain17m, value);
                    _HF.Gain15m = LookupKKCSVValue("Gain 15", _HF.Gain15m, value);
                    _HF.Gain12m = LookupKKCSVValue("Gain 12", _HF.Gain12m, value);
                    _HF.Gain10m = LookupKKCSVValue("Gain 10", _HF.Gain10m, value);
                    _HF.Gain6m = LookupKKCSVValue("Gain 6", _HF.Gain6m, value);

                }

                // save the drive setting for each band
                MicroMHz.Drive50 = LookupKKCSVValue("Drive 50", MicroMHz.Drive50, value);
                MicroMHz.Drive144 = LookupKKCSVValue("Drive 144", MicroMHz.Drive144, value);
                MicroMHz.Drive222 = LookupKKCSVValue("Drive 222", MicroMHz.Drive222, value);
                MicroMHz.Drive432 = LookupKKCSVValue("Drive 432", MicroMHz.Drive432, value);
                MicroMHz.Drive903 = LookupKKCSVValue("Drive 903", MicroMHz.Drive903, value);
                MicroMHz.Drive1296 = LookupKKCSVValue("Drive 1296", MicroMHz.Drive1296, value);
                MicroMHz.Drive2304 = LookupKKCSVValue("Drive 2304", MicroMHz.Drive2304, value);
                MicroMHz.Drive3456 = LookupKKCSVValue("Drive 3456", MicroMHz.Drive3456, value);
                MicroMHz.Drive5760 = LookupKKCSVValue("Drive 5760", MicroMHz.Drive5760, value);
                MicroMHz.Drive10368 = LookupKKCSVValue("Drive 10368", MicroMHz.Drive10368, value);
                MicroMHz.Drive24192 = LookupKKCSVValue("Drive 24192", MicroMHz.Drive24192, value);

                // save the gain setting for each band
                MicroMHz.Gain50MHz = LookupKKCSVValue("Gain 50", MicroMHz.Gain50MHz, value);
                MicroMHz.Gain144MHz = LookupKKCSVValue("Gain 144", MicroMHz.Gain144MHz, value);
                MicroMHz.Gain222MHz = LookupKKCSVValue("Gain 222", MicroMHz.Gain222MHz, value);
                MicroMHz.Gain432MHz = LookupKKCSVValue("Gain 432", MicroMHz.Gain432MHz, value);
                MicroMHz.Gain903MHz = LookupKKCSVValue("Gain 903", MicroMHz.Gain903MHz, value);
                MicroMHz.Gain1296MHz = LookupKKCSVValue("Gain 1296", MicroMHz.Gain1296MHz, value);
                MicroMHz.Gain2304MHz = LookupKKCSVValue("Gain 2304", MicroMHz.Gain2304MHz, value);
                MicroMHz.Gain3456MHz = LookupKKCSVValue("Gain 3456", MicroMHz.Gain3456MHz, value);
                MicroMHz.Gain5760MHz = LookupKKCSVValue("Gain 5760", MicroMHz.Gain5760MHz, value);
                MicroMHz.Gain10368MHz = LookupKKCSVValue("Gain 10368", MicroMHz.Gain10368MHz, value);
                MicroMHz.Gain24192MHz = LookupKKCSVValue("Gain 24192", MicroMHz.Gain24192MHz, value);

                //save minimum and maximum xvtr frequencies for each band
                xvtr_frequency_50_minimum = LookupKKCSVValue("XVTR 50 MHz minimum frequency", xvtr_frequency_50_minimum, value);
                xvtr_frequency_50_maximum = LookupKKCSVValue("XVTR 50 MHz maximum frequency", xvtr_frequency_50_maximum, value);
                xvtr_frequency_144_minimum = LookupKKCSVValue("XVTR 144 MHz minimum frequency", xvtr_frequency_144_minimum, value);
                xvtr_frequency_144_maximum = LookupKKCSVValue("XVTR 144 MHz maximum frequency", xvtr_frequency_144_maximum, value);
                xvtr_frequency_222_minimum = LookupKKCSVValue("XVTR 222 MHz minimum frequency", xvtr_frequency_222_minimum, value);
                xvtr_frequency_222_maximum = LookupKKCSVValue("XVTR 222 MHz maximum frequency", xvtr_frequency_222_maximum, value);
                xvtr_frequency_432_minimum = LookupKKCSVValue("XVTR 432 MHz minimum frequency", xvtr_frequency_432_minimum, value);
                xvtr_frequency_432_maximum = LookupKKCSVValue("XVTR 432 MHz maximum frequency", xvtr_frequency_432_maximum, value);
                xvtr_frequency_903_minimum = LookupKKCSVValue("XVTR 903 MHz minimum frequency", xvtr_frequency_903_minimum, value);
                xvtr_frequency_903_maximum = LookupKKCSVValue("XVTR 903 MHz maximum frequency", xvtr_frequency_903_maximum, value);
                xvtr_frequency_1296_minimum = LookupKKCSVValue("XVTR 1296 MHz minimum frequency", xvtr_frequency_1296_minimum, value);
                xvtr_frequency_1296_maximum = LookupKKCSVValue("XVTR 1296 MHz maximum frequency", xvtr_frequency_1296_maximum, value);
                xvtr_frequency_2304_minimum = LookupKKCSVValue("XVTR 2304 MHz minimum frequency", xvtr_frequency_2304_minimum, value);
                xvtr_frequency_2304_maximum = LookupKKCSVValue("XVTR 2304 MHz maximum frequency", xvtr_frequency_2304_maximum, value);
                xvtr_frequency_3456_minimum = LookupKKCSVValue("XVTR 3456 MHz minimum frequency", xvtr_frequency_3456_minimum, value);
                xvtr_frequency_3456_maximum = LookupKKCSVValue("XVTR 3456 MHz maximum frequency", xvtr_frequency_3456_maximum, value);
                xvtr_frequency_5760_minimum = LookupKKCSVValue("XVTR 5760 MHz minimum frequency", xvtr_frequency_5760_minimum, value);
                xvtr_frequency_5760_maximum = LookupKKCSVValue("XVTR 5760 MHz maximum frequency", xvtr_frequency_5760_maximum, value);
                xvtr_frequency_10368_minimum = LookupKKCSVValue("XVTR 10368 MHz minimum frequency", xvtr_frequency_10368_minimum, value);
                xvtr_frequency_10368_maximum = LookupKKCSVValue("XVTR 10368 MHz maximum frequency", xvtr_frequency_10368_maximum, value);
                xvtr_frequency_24192_minimum = LookupKKCSVValue("XVTR 24192 MHz minimum frequency", xvtr_frequency_24192_minimum, value);
                xvtr_frequency_24192_maximum = LookupKKCSVValue("XVTR 24192 MHz maximum frequency", xvtr_frequency_24192_maximum, value);
                frequency_160_minimum = LookupKKCSVValue("XVTR 160 minimum frequency", frequency_160_minimum, value);
                frequency_160_maximum = LookupKKCSVValue("XVTR 160 maximum frequency", frequency_160_maximum, value);
                frequency_80_minimum = LookupKKCSVValue("XVTR 80 minimum frequency", frequency_80_minimum, value);
                frequency_80_maximum = LookupKKCSVValue("XVTR 80 maximum frequency", frequency_80_maximum, value);
                frequency_40_minimum = LookupKKCSVValue("XVTR 40 minimum frequency", frequency_40_minimum, value);
                frequency_40_maximum = LookupKKCSVValue("XVTR 40 maximum frequency", frequency_40_maximum, value);
                frequency_30_minimum = LookupKKCSVValue("XVTR 30 minimum frequency", frequency_30_minimum, value);
                frequency_30_maximum = LookupKKCSVValue("XVTR 30 maximum frequency", frequency_30_maximum, value);
                frequency_20_minimum = LookupKKCSVValue("XVTR 20 minimum frequency", frequency_20_minimum, value);
                frequency_20_maximum = LookupKKCSVValue("XVTR 20 maximum frequency", frequency_20_maximum, value);
                frequency_17_minimum = LookupKKCSVValue("XVTR 17 minimum frequency", frequency_17_minimum, value);
                frequency_17_maximum = LookupKKCSVValue("XVTR 17 maximum frequency", frequency_17_maximum, value);
                frequency_15_minimum = LookupKKCSVValue("XVTR 15 minimum frequency", frequency_15_minimum, value);
                frequency_15_maximum = LookupKKCSVValue("XVTR 15 maximum frequency", frequency_15_maximum, value);
                frequency_12_minimum = LookupKKCSVValue("XVTR 12 minimum frequency", frequency_12_minimum, value);
                frequency_12_maximum = LookupKKCSVValue("XVTR 12 maximum frequency", frequency_12_maximum, value); 
                frequency_10_minimum = LookupKKCSVValue("XVTR 10 minimum frequency", frequency_10_minimum, value);
                frequency_10_maximum = LookupKKCSVValue("XVTR 10 maximum frequency", frequency_10_maximum, value);
                frequency_6_minimum = LookupKKCSVValue("XVTR 6 minimum frequency", frequency_6_minimum, value);
                frequency_6_maximum = LookupKKCSVValue("XVTR 6 maximum frequency", frequency_6_maximum, value);
                frequency_GC_minimum = LookupKKCSVValue("XVTR GC minimum frequency", frequency_GC_minimum, value);
                frequency_GC_maximum = LookupKKCSVValue("XVTR GC maximum frequency", frequency_GC_maximum, value); 

                MicroMHz.PennyOC = LookupKKCSVValue("Penny OC Enable", MicroMHz.PennyOC, value);
                
                LFootMainBut.Checked = LookupKKCSVValue("LFootMainBut", LFootMainBut.Checked, value);
                LFootAuxBut.Checked = LookupKKCSVValue("LFootAuxBut", LFootAuxBut.Checked, value);
                KeyMainBut.Checked = LookupKKCSVValue("KeyMainBut", KeyMainBut.Checked, value);
                KeyAuxBut.Checked = LookupKKCSVValue("KeyAuxBut", KeyAuxBut.Checked, value);

      //          Properties.Settings.Default.N1MMCOM = LookupKKCSVValue("N1MM COM Port", Properties.Settings.Default.N1MMCOM, value);
      //          Properties.Settings.Default.N1MMCOMLiaison = LookupKKCSVValue("N1MM COM Liaison Port", Properties.Settings.Default.N1MMCOMLiaison, value);
                
                Globals.CWPitch = LookupKKCSVValue("Globals CWPitch", Globals.CWPitch, value);
                Globals.sidetonevol = (float)LookupKKCSVValue("Sidetone Volume", Globals.sidetonevol, value);

            }
        //    catch
            {
      //          MessageBox.Show("Failed to read CSV File");
            }
            
            
            }

        void GetValidAlexState(string name, ref int state, List<string> value)
        {
            state = LookupKKCSVValue(name, state, value);
            if ((state & 0x3) == 0)
            {
                // if rx antenna selector is 0, set it to 1
                state |= 1;
            }
            if (((state >> 6) & 0x3) == 0)
            {
                // if tx antenna selector is 0, set it to 1
                state |= 64;
            }
        }
    }
}
